ccccc This program is intended for nonlinear error correction models
c     It checks the estimation power of MLE method for (L)TVECM
c     Created on August 2001 by Antoni Vidiella
c     modified in December 2002 (Annals of Econometrics)
c     GRID SEARCH
c
c     Current setting
c
c     Number-variables = 2
c     max-obs  = 400
c     maximum number of regimes = 2
c
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      parameter(nmax=400,ipmax=5)
      dimension dat(nmax,ipmax),rnn(ipmax),elp2(ipmax,ipmax)
      dimension dat2(nmax,ipmax),dat3(nmax,ipmax),dat4(nmax,ipmax)
      dimension y1(nmax,ipmax),x1(nmax,ipmax),x2(ipmax,nmax)
      dimension x3(ipmax,ipmax),x4(ipmax,ipmax),x5(nmax,ipmax)
      dimension x6(ipmax,2),x7(nmax,2),x8(nmax,2),zj(nmax,ipmax)
      dimension elp1(ipmax,ipmax),hreg(ipmax,ipmax,2)
      dimension bcan(1100),post(1000),x18(nmax,2)
      dimension desv1(ipmax),w(nmax),z(nmax,ipmax)
      dimension det1(1000,1000),x9(ipmax,ipmax),x10(nmax,ipmax)
      dimension ri(400),x41(ipmax,2),var(ipmax),cn(ipmax,ipmax)
      dimension x43(ipmax,2),dat5(1000+nmax,ipmax),d1(nmax)
      dimension err1(1000),h1(ipmax,ipmax),wk(2,2)
      dimension zzj(nmax,ipmax),zzj1(ipmax,nmax),x11(ipmax,ipmax)
      dimension x12(ipmax,ipmax),x13(ipmax,2),x14(ipmax,2)
      dimension x15(nmax,2),x16(2,nmax),x17(2,2)
      dimension d8(nmax,2),d9(nmax,2),c2(ipmax),c3(ipmax)
      dimension desv2(ipmax),desv3(ipmax),w2(nmax)
      dimension x20(ipmax,2),x21(nmax,2),x22(nmax,2),x23(2,nmax)
      dimension x24(2,2),x25(2,nmax),x26(2,2),x27(2,2),x28(2,2)
      dimension x29(2,2),x30(2,2),x31(2,2),x32(2,2),x33(2,2)
      dimension fv1(2),iv1(2),z1(2,2),xlag(nmax,2),elp3(2,2)
      dimension wr(2),wi(2),beta2(2),beta4(2),thr(3)
      dimension dat8(nmax,ipmax),beta3(2)
c
      integer seed      
      intrinsic dmin1
c
c
ccccc Introduction of data
c
      open (10,file='mlef11.res',status='unknown')
c      seed=4879666
      irun=2000
      is=1
      ip=2
      nob=400
      ierr1=1
      trim=0.1
      sig=6.0
      iprec=2
      b1=1.5
      a1=0.0
      a2=-1.0
      rho=0.0
      theta=0.0
      sigma=2.0
      do 153 ia=1,2
           do 153 i=1,2
              do 153 j=1,2
 153           hreg(i,j,ia)=0.0
      hreg(1,1,1)=-0.8
      hreg(1,2,1)=1.6
      hreg(1,3,1)=0.0
      hreg(2,1,1)=0.0      
      hreg(2,2,1)=0.0
      hreg(2,3,1)=0.0 
      hreg(1,1,2)=-0.8
      hreg(1,2,2)=0.8
      hreg(1,3,2)=0.0      
      hreg(2,1,2)=0.0
      hreg(2,2,2)=0.0
      hreg(2,3,2)=0.0
      beta3(1)=2.0
      beta3(2)=1.0
      err=0.0      
      call zeromat(x41,ipmax,ipmax,2)  
      do 930 iv=1,irun
 821  continue            
         dat5(1,1)=0.0
         dat5(1,2)=0.0
         call zerovec(var,ipmax,ipmax)
         do 192 ik=1,nob+20
            do 194 j=1,2
               if (ik.gt.1) dat5(ik,j)=dat5(ik-1,j)+var(j)
 194        continue
            err=dat5(ik,1)-b1*dat5(ik,2)
            ia=1
            if(err.gt.0.0) ia=2
            d=(a1*beta3(ia)-a2)
            do 196 j=1,2
               x41(j,1)=dat5(ik,j)
               x41(j,2)=dat5(ik,j)
 196           x41(3,j)=var(j)
            call zerovec(var,ipmax,ipmax)
            CALL ZEROVEC(RI,400,10)
            CALL GNORM(RI,2,SEED)
            ezt=ri(1)
            ewt=ri(1)*theta*sigma+ri(2)*sqrt((sigma**2)-
     1          (theta*sigma)**2)
            rnn(1)=(1/d)*(-a2*ezt+beta3(ia)*ewt)
            rnn(2)=(1/d)*(-a1*ezt+ewt)
c            rnn(1)=ri(1)
c            rnn(2)=ri(2)
            do 161 i=1,2
               do 161 j=1,3
 161              h1(i,j)=hreg(i,j,ia)
            call zeromat(x43,ipmax,ipmax,2)
            call multmat(h1,x41,x43,ipmax,ipmax,2,3,2)
            do 197 j=1,2
 197           var(j)=x43(j,j)+rnn(j)
               call zeromat(x41,ipmax,ipmax,2)               
               call zerovec(rnn,ipmax,ipmax)
 192        continue
            do 193 i=21,nob+20
               do 193 j=1,2
 193              dat(i-20,j)=dat5(i,j)
c            do 198 i=1,nob
c 198           write(10,*) (dat(i,j),j=1,2)
            icount9=0
            isgn=0
            sgn1=0.0
            do 199 i=1,nob
 199           if((dat(i,1)-b1*dat(i,2)).gt.0.0) icount9=icount9+1            
            call eqmat(dat,dat8,nmax,nmax,nob,2)
            call adf(dat8,nmax,nob,iadft,b1)
            sgn1=real(icount9)/real(nob)
c            write(6,*) sgn1
            if((sgn1.lt.0.45).or.((1.0-sgn1).lt.0.45)) isgn=1
            if (iadft.eq.0.or.isgn.eq.1) goto 821
            call zeromat(dat5,1000+nmax,1000+nob,ipmax)
            call zeromat(dat4,nmax,nob,ipmax)
            call zeromat(dat2,nmax,nob,ipmax)
            call zeromat(dat3,nmax,nob,ipmax)           
c in dat we have the simulated set of data, dat(i,j)
c begin of the threshold search
         do 60 i=1,nob-ip
c              x1(i,1)=1.0
              do 610 j=1,ip-1 
                 do 610 k=1,2
 610              x1(i,k+2*(j-1))=dat(ip+i-j,k)-dat(ip+i-j-1,k)
 60      continue
         do 70 i=ip,nob-1
           do 70 j=1,2
 70            y1(i-ip+1,j)=dat(i+1,j)-dat(i,j)
      icnt=nob-ip
      ior=(ip-1)*2
      call zeromat(x4,ipmax,ipmax,ipmax)
      call trnmat(x1,x2,nmax,ipmax,icnt,ior)
      call multmat(x2,x1,x3,ipmax,nmax,ior,icnt,ior)
      call matinv(x3,x4,elp1,ipmax,ior,ifail)      
      call multmat(x1,x4,x5,nmax,ipmax,icnt,ior,ior)
      call multmat(x2,y1,x6,ipmax,nmax,ior,icnt,2)
      call multmat(x5,x6,x7,nmax,ipmax,icnt,ior,2)
      call addmat(y1,x7,x8,nmax,icnt,2,-1)
      call zeromat(det1,1000,1000,1000)
      inam=10**iprec+1
      if (ierr1.eq.1) then
         do 600 i=ip,nob-1
            do 600 j=1,2
 600           xlag(i-1,j)=dat(i,j)
         call multmat(x2,xlag,x20,ipmax,nmax,ior,icnt,2)
         call multmat(x5,x20,x21,nmax,ipmax,icnt,ior,2)
         call addmat(xlag,x21,x22,nmax,icnt,2,-1)
         call trnmat(x8,x23,nmax,2,icnt,2)
         call multmat(x23,x8,x24,2,nmax,2,icnt,2)
         call trnmat(x22,x25,nmax,2,icnt,2)
         call multmat(x25,x22,x26,2,nmax,2,icnt,2)
         call zeromat(x27,2,2,2)
         call matinv(x26,x27,elp3,2,2,ifail)
         call multmat(x25,x8,x28,2,nmax,2,icnt,2)
         call zeromat(x29,2,2,2)
         call matinv(x24,x29,elp3,2,2,ifail)
         call trnmat(x28,x30,2,2,2,2)
         call multmat(x29,x30,x31,2,2,2,2,2)
         call multmat(x28,x31,x32,2,2,2,2,2)
         call multmat(x27,x32,x33,2,2,2,2,2) 
         call rg(2,2,x33,wr,wi,z1,iv1,fv1,ierr)
         ind=1
         if(wr(1).lt.wr(2)) ind=2
         beta=-z1(2,ind)/z1(1,ind)
         beta2(1)=1.0
         beta2(2)=-beta
         call like(x1,xlag,beta2,y1,nmax,icnt,alike)
         beta2(2)=-(beta+1.d-3)
         call like(x1,xlag,beta2,y1,nmax,icnt,alike1)
         beta2(2)=-(beta-1.d-3)
         call like(x1,xlag,beta2,y1,nmax,icnt,alike2)
         hp=(alike1+alike2-2.0*alike)/(1.d-3**2)
         seb=1.0/dsqrt(hp)
         call zerovec(bcan,1100,nob)
         upl=0.0
         bol=0.0
         upl=beta+sig*seb
         bol=beta-sig*seb
         step=(upl-bol)/real(10**iprec)
         bcan(1)=bol
         do 45 im=2,10**iprec+1
 45         bcan(im)=bcan(im-1)+step
      else
         inam=1
         beta=1.5
         bcan(1)=beta
      endif            
      call zerovec(err1,1000,nob)
      do 44 it=1, nob
 44      err1(it)=dat(it,1)-beta*dat(it,2)
      call zerovec(post,1000,nob)
      ipa=400
      if (is.eq.0) then
         CALL QCKSRT(nob,err1)
         up=0.0
         bo=0.0
         up=err1(nob)
         bo=err1(1)
         step=0.0
         step=(up-bo)/real(ipa)
         post(1)=bo
         do 49 im=2,ipa
 49         post(im)=post(im-1)+step
      else if(is.eq.1) then
         ipa=0
         call pcand(err1,nob,post,trim,1-trim,ipa)
      else if(is.eq.2) then
         open(17,file='cand.dat',status='unknown')         
         do 491 ii=1,ipa
 491        read(17,*) post(ii)
      else if(is.eq.3) then
         ipa=1
         post(1)=0.0
      endif
      do 900 ix=1,ipa
c      iz is the index for the cointegration parameter
         do 910 iz=1,inam
            do 47 i=1,icnt
               w(i)=dat(i+1,1)-bcan(iz)*dat(i+1,2)
               z(i,1)=w(i)
               do 47 k=1,ior
 47               z(i,1+k)=x1(i,k)
            a11=0.0
            call zerovec(d1,nmax,icnt)
            do 100 it = 1,icnt
               if(w(it).le.post(ix)) d1(it)=1.0
 100           a11=a11+d1(it)   
            if (dmin1((a11/dble(nob)),(nob-a11)/dble(nob)).gt.trim) then
               do 110 i=1,icnt
                  do 120 j=1,1+ior
 120                 zj(i,j)=z(i,j)*d1(i)
 110              zj(i,2+ior)=w(i)
                  call multmat(x2,zj,x9,ipmax,nmax,ior,icnt,2+ior)
                  call multmat(x5,x9,x10,nmax,ipmax,icnt,ior,2+ior)                  
                  call addmat(zj,x10,zzj,nmax,icnt,2+ior,-1)
                  call trnmat(zzj,zzj1,nmax,ipmax,icnt,2+ior)
                  call multmat(zzj1,zzj,x11,ipmax,nmax,ior+2,icnt,ior+2)
                  call zeromat(x12,ipmax,ipmax,ipmax)
                  call matinv(x11,x12,elp2,ipmax,ior+2,ifail)      
                  call multmat(zzj1,x8,x13,ipmax,nmax,ior+2,icnt,2)
                  call multmat(x12,x13,x14,ipmax,ipmax,ior+2,ior+2,2)
                  call multmat(zzj,x14,x15,nmax,ipmax,icnt,ior+2,2)
                  call addmat(x8,x15,x18,nmax,icnt,2,-1)
                  call trnmat(x18,x16,nmax,2,icnt,2)
                  call multmat(x16,x18,x17,2,nmax,2,icnt,2)
                  do 130 i=1,2
                     do 130 j=1,2
 130                    x17(i,j)=x17(i,j)/real(icnt)
                  det=0.0
                  call zeromat(wk,2,2,2)
                  call detmtx(x17,wk,2,2,det)
                  det1(iz,ix)=(real(icnt)/2.0)*dlog(dble(det))
                  call zeromat(zj,nmax,nob,ipmax)
                  call zerovec(w,nmax,nob)
                  call zeromat(z,nmax,nob,ipmax)
                  call zeromat(x16,2,2,nob)
                  call zeromat(x17,2,2,2)
                  call zeromat(x12,ipmax,ipmax,ipmax)
                  call zeromat(x13,ipmax,ipmax,2)
                  call zeromat(x11,ipmax,ipmax,ipmax)
                  call zeromat(x14,ipmax,ipmax,2)
                  call zeromat(x9,ipmax,ipmax,ipmax)
                  call zeromat(x15,nmax,nob,2)
                  call zeromat(x18,nmax,nob,2)
                  call zeromat(x10,nmax,ipmax,ipmax)
                  call zeromat(zzj,nmax,nob,ipmax)
                  call zeromat(zzj1,ipmax,ipmax,nob)
                  call zeromat(elp1,ipmax,ipmax,ipmax)
                else
                  det1(iz,ix)=9.d+10
                endif
c              write(10,*) thr(nreg),det1(isim),isim
 910        continue
 900     continue
         ibm=1
         itm=1
         detmin=det1(1,1)
         do 920 i=1,inam
           do 920 j=1,ipa
              if (det1(i,j).lt.detmin) then
                 detmin=det1(i,j)
                 ibm=i
                 itm=j
              endif
 920     continue
         do 800 i=1,nob-1
 800        w2(i)=dat(i,1)-bcan(ibm)*dat(i,2)
         icnt = 0
         thr(1)=-9.d+10
         thr(2)=post(itm)
         thr(3)=9.d+10
         call zeromat(y1,nmax,nob,ipmax)
         call zeromat(x1,nmax,nob,ipmax)
         call zeromat(x2,ipmax,ipmax,nob)
         call zeromat(x3,ipmax,ipmax,ipmax)
         call zeromat(x4,ipmax,ipmax,ipmax)
         call zeromat(x5,nmax,nob,ipmax)
         call zeromat(x6,ipmax,ipmax,2)
         call zeromat(x7,nmax,nob,2)
         call zeromat(x8,nmax,nob,2)
         do 333 ia=1,2
            icnt=0
            do 334 it = 2,nob-1  
               if(w2(it).lt.thr(ia)) go to 334
               if(w2(it).gt.thr(ia+1)) go to 334
               icnt = icnt+1
c               x1(icnt,1)=1.0
               do 335 j=1,ip-1
                  do 335 k=1,2
 335           x1(icnt,k+2*(j-1))=dat(ip+it-j-1,k)-dat(ip+it-j-2,k)
                  do 336 j=1,2
                    y1(icnt-ip+2,j)=dat(it+1,j)-dat(it,j)
 336                xlag(icnt,j)=dat(it-1,j)
 334          continue            
            ior=(ip-1)*2
            call trnmat(x1,x2,nmax,ipmax,icnt,ior)
            call multmat(x2,x1,x3,ipmax,nmax,ior,icnt,ior)
            call matinv(x3,x4,elp1,ipmax,ior,ifail)      
            call multmat(x1,x4,x5,nmax,ipmax,icnt,ior,ior)
            call multmat(x2,y1,x6,ipmax,nmax,ior,icnt,2)
            call multmat(x5,x6,x7,nmax,ipmax,icnt,ior,2)
            call addmat(y1,x7,x8,nmax,icnt,2,-1)
            call multmat(x2,xlag,x20,ipmax,nmax,ior,icnt,2)
            call multmat(x5,x20,x21,nmax,ipmax,icnt,ior,2)
            call addmat(xlag,x21,x22,nmax,icnt,2,-1)
            call trnmat(x8,x23,nmax,2,icnt,2)
            call multmat(x23,x8,x24,2,nmax,2,icnt,2)
            call trnmat(x22,x25,nmax,2,icnt,2)
            call multmat(x25,x22,x26,2,nmax,2,icnt,2)
            call zeromat(x27,2,2,2)
            call matinv(x26,x27,elp3,2,2,ifail)
            call multmat(x25,x8,x28,2,nmax,2,icnt,2)
            call zeromat(x29,2,2,2)
            call matinv(x24,x29,elp3,2,2,ifail)
            call trnmat(x28,x30,2,2,2,2)
            call multmat(x29,x30,x31,2,2,2,2,2)
            call multmat(x28,x31,x32,2,2,2,2,2)
            call multmat(x27,x32,x33,2,2,2,2,2) 
            call rg(2,2,x33,wr,wi,z1,iv1,fv1,ierr)
            ind=1
            if(wr(1).lt.wr(2)) ind=2
            beta4(ia)=-z1(2,ind)/z1(1,ind)
            call zeromat(y1,nmax,nob,ipmax)
            call zeromat(x1,nmax,nob,ipmax)
            call zeromat(x2,ipmax,ipmax,nob)
            call zeromat(x3,ipmax,ipmax,ipmax)
            call zeromat(x4,ipmax,ipmax,ipmax)
            call zeromat(x5,nmax,nob,ipmax)
            call zeromat(x6,ipmax,ipmax,2)
            call zeromat(x7,nmax,nob,2)
            call zeromat(x8,nmax,nob,2)
            call zeromat(xlag,nmax,nob,2)
            call zeromat(x20,ipmax,ipmax,2)
            call zeromat(x21,nmax,nob,2)
            call zeromat(x22,nmax,nob,2)
            call zeromat(x23,2,2,nob)
            call zeromat(x24,2,2,2)
            call zeromat(x25,2,2,nob)
            call zeromat(x26,2,2,2)
            call zeromat(x27,2,2,2)
            call zeromat(x28,2,2,2)            
            call zeromat(x29,2,2,2)            
            call zeromat(x30,2,2,2)
            call zeromat(x31,2,2,2)            
            call zeromat(x32,2,2,2)
            call zeromat(x33,2,2,2)           
333    continue
         write(10,508) post(itm),bcan(ibm),beta4(1),beta4(2)
         write(6,508) post(itm),bcan(ibm),beta4(1),beta4(2)
         call zeromat(d8,nmax,nmax,2)
         call zeromat(d9,nmax,nmax,2)
         call zeromat(dat,nmax,nob,ipmax)
c         stop
 930  continue
 508   format(f10.5,2x,f10.5,2x,f10.5,2x,f10.5)
      end       

      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      call zeromat(cmat,id1max,l1,l3)
      DO 99 J=1,L3
         DO 98 K=1,L2
            IF (BMAT(K,J).EQ.0.0) GOTO 98
            DO 97 I=1,L1
               CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END      

      SUBROUTINE MATINV(AMAT,BMAT,ELP,ID1MAX,L1,IFAIL)
C************************************************************************
C     PORPOSE: MATRIX INVERSION
C     INPUT: AMAT, MATRIX DIMENSION L1,L1
C     OUTPUT: BMAT, MATRIX DIMENSION L1,L1
C             IFAIL, MONITORING VALUE
C************************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),ELP(ID1MAX,*)
      EXTERNAL EQMAT,ZEROMAT
C     
      CALL ZEROMAT(ELP,ID1MAX,L1,L1)
      CALL EQMAT(AMAT,ELP,ID1MAX,ID1MAX,L1,L1)
      DO 115 I=1,L1
         BMAT(I,I)=1.0
  115 CONTINUE
      DO 99 J=1,L1
         DO 98 I=J,L1
            IF (ELP(I,J).NE.0.0) GOTO 11
   98    CONTINUE
         IFAIL=1
         RETURN
   11    CONTINUE
      DO 97 K=1,L1
C
         PIVOT01= ELP(J,K)
         ELP(J,K)= ELP(I,K)
         ELP(I,K)= PIVOT01
C
         PIV= BMAT(J,K)
         BMAT(J,K)=BMAT(I,K)
         BMAT(I,K)= PIV
   97 CONTINUE
C
      IF(ELP(J,J).NE.0.0) GOTO 22
C
      IFAIL=1
      RETURN
C
C
   22 CONTINUE
      PPP= 1.0/ELP(J,J)
      DO 96 K=1,L1
C
         ELP(J,K)= ELP(J,K)*PPP
         BMAT(J,K)= BMAT(J,K)*PPP
   96 CONTINUE
C
      DO 95 K=1,L1
C
         IF(J.EQ.K) THEN
C
   33       CONTINUE
C
         ELSE
            PPP= ELP(K,J)
            DO 94 L=1,L1
C
               ELP(K,L)=ELP(K,L)-ELP(J,L)*PPP
               BMAT(K,L)=BMAT(K,L)-BMAT(J,L)*PPP
   94       CONTINUE
C
         END IF
   95 CONTINUE
   99 CONTINUE
C
      RETURN
      END

     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
         DO 99 I=1,L1
            AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION VEC(ID1MAX)

      DO 98 I=1,L1     
                VEC(I)=0.0
  98  CONTINUE
      RETURN
        END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
      external zeromat
      call zeromat(bmat,id2max,l1,l2)
      DO 98 J=1,L2
         DO 99 I=1,L1
            BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END

      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
            VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END

      SUBROUTINE TRNMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C********************************************************************
C     PORPOSE: TRANSPOSE A MATRIX OF DIMENSION L1,L2
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: BMAT, TRANSPOSED MATRIX DIMENSION L2,L1
C********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
      external zeromat
      call zeromat(bmat,id2max,l2,l1)
      DO 98 J=1,L2
         DO 99 I=1,L1
            BMAT(J,I)=AMAT(I,J)
   99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      CALL ZEROMAT(CMAT,ID1MAX,L1,L2)
      DO 2 J=1,L1
         DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END

      SUBROUTINE reg(dat,ID1MAX,nob,coef,desv,icf)
C**********************************************************************
C     PORPOSE: OLS ESTIMATES (NON RESTRICTED)
C**********************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION dat(ID1MAX,*),coef(*),dat1(400,3),dat2(3,400),dat3(3,3)
      dimension dat4(3,3),dat5(3,400),y(400,1),elp2(3,3),desv(*)
      dimension dat6(400,3)
      external multmat,matinv,trnmat,zeromat,zerovec
      s1=0.0
      s2=0.0
      s3=0.0
      call zeromat(dat1,400,400,3)
      call zeromat(dat2,3,3,400)
      call zeromat(dat3,3,3,3)
      call zeromat(dat4,3,3,3)
      call zeromat(dat5,3,3,400)
      call zerovec(coef,3,3)
      call zerovec(desv,3,3)
      call zeromat(dat6,400,400,3)
      call zeromat(y,400,400,1)
      do 100 i=1,nob
         y(i,1)=dat(i,1)
         if (icf.eq.1) dat1(i,1)=1.0
 100     dat1(i,1+icf)=dat(i,2)
      call trnmat(dat1,dat2,400,3,nob,1+icf)
      call multmat(dat2,dat1,dat3,3,400,1+icf,nob,1+icf)
      call matinv(dat3,dat4,elp2,3,1+icf,ifail)
      call multmat(dat4,dat2,dat5,3,3,1+icf,1+icf,nob)
      call multmat(dat5,y,coef,3,400,1+icf,nob,1)
      err=0.0
      call multmat(dat1,coef,dat6,400,3,nob,1+icf,1)
      do 110 i=1,nob
 110     err=err+(y(i,1)-dat6(i,1))**2
      xse=err/real(nob-(1+icf))
      do 120 i=1,icf+1
 120    desv(i)=sqrt(dat4(i,i)*xse)      
      end

      SUBROUTINE PCAND(X,N,CTHD,IPL,IPU,IPR)
C**************************************************************
C DEFINES CANDIDATE THRESHOLD VALUES FOR INFLATION RATES
C THRESHOLD VALUES ARE SEARCHED AMONG THE INTERPERCENTILE RANGE
C @ EQUIWIDTH INTERVALS ( # INTERVALS = # VALUES BETWEEN PERC)
C X = MATRIX OF DATA
C N = # DATA
C CTHD = ARRAY OF CANDIDATE THRESHOLD VALUES
C IPL = USER-SUPPLIED LOWER PERCENTILE
C IPU = USER-SUPPLIED UPPER PERCENTILE
C EXTERNAL SUBROUTINE = QCKSRT
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 IPL,IPU
      DIMENSION X(*),CTHD(*),SARR(1000)
      EXTERNAL QCKSRT
      DO 12 I=1,N
 12      SARR(I)=X(I)
      CALL QCKSRT(N,SARR)
      IP1=NINT(IPL*N)
      AMIN=SARR(IP1)
      IP2=NINT(IPU*N)
      AMAX=SARR(IP2)
      IPR=IP2-IP1
      AI=AMAX-AMIN
      AINC=AI/REAL(IPR)
      CTHD(1)=AMIN
      DO 13 J=2,IPR
 13      CTHD(J)=CTHD(J-1)+AINC
      RETURN
      END

C#####################################################
C Quicksort routine from numerical recipes
C#####################################################
      SUBROUTINE QCKSRT(N,ARR)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (M=7,NSTACK=50,FM=7875.,FA=211.,FC=1663.
     *    ,FMI=1.2698413E-4,maxdat=1000)
      DIMENSION ISTACK(NSTACK)
      DIMENSION ARR(maxdat)
C     DOUBLE PRECISION A
      JSTACK=0
      L=1
      IR=N
      FX=0.
10    IF(IR-L.LT.M)THEN
        DO 13 J=L+1,IR
          A=ARR(J)
          DO 11 I=J-1,1,-1
            IF(ARR(I).LE.A)GO TO 12
            ARR(I+1)=ARR(I)
11        CONTINUE
          I=0
12        ARR(I+1)=A
13      CONTINUE
        IF(JSTACK.EQ.0)RETURN
        IR=ISTACK(JSTACK)
        L=ISTACK(JSTACK-1)
        JSTACK=JSTACK-2
      ELSE
        I=L
        J=IR
        FX=MOD(FX*FA+FC,FM)
        IQ=L+(IR-L+1)*(FX*FMI)
        A=ARR(IQ)
        ARR(IQ)=ARR(L)
20      CONTINUE
21        IF(J.GT.0)THEN
            IF(A.LT.ARR(J))THEN
              J=J-1
              GO TO 21
            ENDIF
          ENDIF
          IF(J.LE.I)THEN
            ARR(I)=A
            GO TO 30
          ENDIF
          ARR(I)=ARR(J)
          I=I+1
22        IF(I.LE.N)THEN
            IF(A.GT.ARR(I))THEN
              I=I+1
              GO TO 22
            ENDIF
          ENDIF
          IF(J.LE.I)THEN
            ARR(J)=A
            I=J
            GO TO 30
          ENDIF
          ARR(J)=ARR(I)
          J=J-1
        GO TO 20
30      JSTACK=JSTACK+2
        IF(JSTACK.GT.NSTACK)PAUSE 'NSTACK must be made larger.'
        IF(IR-I.GE.I-L)THEN
          ISTACK(JSTACK)=IR
          ISTACK(JSTACK-1)=I+1
          IR=I-1
        ELSE
          ISTACK(JSTACK)=I-1
          ISTACK(JSTACK-1)=L
          L=I+1
        ENDIF
      ENDIF
      GO TO 10
      END

       subroutine gnorm(r,nr,rs)
       implicit double precision (a-h,o-z)
       integer nr,rs
       dimension r(*)
       do  1 i=1,nr
99        continue         
          v=random()*2.-1.
          u=random()*2.-1.
          w=v*v+u*u
          if(w.gt.1)goto 99
          c=sqrt(-2.*dlog(w)/w)
          R(i)=c*v
          r(i+1)=c*u
1      continue
       return
       end                      

       subroutine date_time_seed@
       end            
                   

c*****************************************
       subroutine detmtx(a,wk,mx,k,det)
c
c---- This program computes the determinant of a covariance matrix.
c     It assumes that the variance of each variable is not close to zero.
c     The program transforms the mtx into an upper triangular one.
c
       real*8 a(mx,mx), det, tem, wk(mx,mx), crit
       integer mx, k, i, j, km1
c--------- wk(.,.) is a working area.
c
       if(k.eq.1)then
        det = a(1,1)
        return
       endif
c
       km1 = k-1
       crit = 1.0d-15
c
       do 10 i=1, k
        do 10 j=1, k
 10        wk(i,j) = a(i,j)
c
       do 50 i=1, km1
        if(dabs(a(i,i)).le.crit)then 
         det = 0.0d0
         return
        endif
        tem = wk(i+1,i)/a(i,i)
        do 40 j=i+1, k
 40       wk(i+1,j) = wk(i+1,j)-wk(i,j)*tem
 50      continue
c
       det = 1.0d0
       do 60 i=1, k
 60       det = det*wk(i,i)
c
cc       print*,'det = ', det
c
       return
       end

      subroutine rg(nm,n,a,wr,wi,z,iv1,fv1,ierr)
c
      integer n,nm,is1,is2,ierr,matz
      double precision a(nm,n),wr(n),wi(n),z(nm,n),fv1(n)
      integer iv1(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real general matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real general matrix.
c
c     on output
c
c        wr  and  wi  contain the real and imaginary parts,
c        respectively, of the eigenvalues.  complex conjugate
c        pairs of eigenvalues appear consecutively with the
c        eigenvalue having the positive imaginary part first.
c
c        z  contains the real and imaginary parts of the eigenvectors
c        if matz is not zero.  if the j-th eigenvalue is real, the
c        j-th column of  z  contains its eigenvector.  if the j-th
c        eigenvalue is complex with positive imaginary part, the
c        j-th and (j+1)-th columns of  z  contain the real and
c        imaginary parts of its eigenvector.  the conjugate of this
c        vector is the eigenvector for the conjugate eigenvalue.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for hqr
c           and hqr2.  the normal completion code is zero.
c
c        iv1  and  fv1  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 call  balanc(nm,n,a,is1,is2,fv1)
      call  elmhes(nm,n,is1,is2,a,iv1)
      call  eltran(nm,n,is1,is2,a,iv1,z)
      call  hqr2(nm,n,is1,is2,a,wr,wi,z,ierr)
      if (ierr .ne. 0) go to 50
      call  balbak(nm,n,is1,is2,fv1,n,z)
   50 return
      end

      subroutine balanc(nm,n,a,low,igh,scale)
c
      integer i,j,k,l,m,n,jj,nm,igh,low,iexc
      double precision a(nm,n),scale(n)
      double precision c,f,g,r,s,b2,radix
      logical noconv
c
c     this subroutine is a translation of the algol procedure balance,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine balances a real matrix and isolates
c     eigenvalues whenever possible.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the input matrix to be balanced.
c
c     on output
c
c        a contains the balanced matrix.
c
c        low and igh are two integers such that a(i,j)
c          is equal to zero if
c           (1) i is greater than j and
c           (2) j=1,...,low-1 or i=igh+1,...,n.
c
c        scale contains information determining the
c           permutations and scaling factors used.
c
c     suppose that the principal submatrix in rows low through igh
c     has been balanced, that p(j) denotes the index interchanged
c     with j during the permutation step, and that the elements
c     of the diagonal matrix used are denoted by d(i,j).  then
c        scale(j) = p(j),    for j = 1,...,low-1
c                 = d(j,j),      j = low,...,igh
c                 = p(j)         j = igh+1,...,n.
c     the order in which the interchanges are made is n to igh+1,
c     then 1 to low-1.
c
c     note that 1 is returned for igh if igh is zero formally.
c
c     the algol procedure exc contained in balance appears in
c     balanc  in line.  (note that the algol roles of identifiers
c     k,l have been reversed.)
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      radix = 16.0d0
c
      b2 = radix * radix
      k = 1
      l = n
      go to 100
c     .......... in-line procedure for row and
c                column exchange ..........
   20 scale(m) = j
      if (j .eq. m) go to 50
c
      do 30 i = 1, l
         f = a(i,j)
         a(i,j) = a(i,m)
         a(i,m) = f
   30 continue
c
      do 40 i = k, n
         f = a(j,i)
         a(j,i) = a(m,i)
         a(m,i) = f
   40 continue
c
   50 go to (80,130), iexc
c     .......... search for rows isolating an eigenvalue
c                and push them down ..........
   80 if (l .eq. 1) go to 280
      l = l - 1
c     .......... for j=l step -1 until 1 do -- ..........
  100 do 120 jj = 1, l
         j = l + 1 - jj
c
         do 110 i = 1, l
            if (i .eq. j) go to 110
            if (a(j,i) .ne. 0.0d0) go to 120
  110    continue
c
         m = l
         iexc = 1
         go to 20
  120 continue
c
      go to 140
c     .......... search for columns isolating an eigenvalue
c                and push them left ..........
  130 k = k + 1
c
  140 do 170 j = k, l
c
         do 150 i = k, l
            if (i .eq. j) go to 150
            if (a(i,j) .ne. 0.0d0) go to 170
  150    continue
c
         m = k
         iexc = 2
         go to 20
  170 continue
c     .......... now balance the submatrix in rows k to l ..........
      do 180 i = k, l
  180 scale(i) = 1.0d0
c     .......... iterative loop for norm reduction ..........
  190 noconv = .false.
c
      do 270 i = k, l
         c = 0.0d0
         r = 0.0d0
c
         do 200 j = k, l
            if (j .eq. i) go to 200
            c = c + dabs(a(j,i))
            r = r + dabs(a(i,j))
  200    continue
c     .......... guard against zero c or r due to underflow ..........
         if (c .eq. 0.0d0 .or. r .eq. 0.0d0) go to 270
         g = r / radix
         f = 1.0d0
         s = c + r
  210    if (c .ge. g) go to 220
         f = f * radix
         c = c * b2
         go to 210
  220    g = r * radix
  230    if (c .lt. g) go to 240
         f = f / radix
         c = c / b2
         go to 230
c     .......... now balance ..........
  240    if ((c + r) / f .ge. 0.95d0 * s) go to 270
         g = 1.0d0 / f
         scale(i) = scale(i) * f
         noconv = .true.
c
         do 250 j = k, n
  250    a(i,j) = a(i,j) * g
c
         do 260 j = 1, l
  260    a(j,i) = a(j,i) * f
c
  270 continue
c
      if (noconv) go to 190
c
  280 low = k
      igh = l
      return
      end

      subroutine elmhes(nm,n,low,igh,a,int)
c
      integer i,j,m,n,la,nm,igh,kp1,low,mm1,mp1
      double precision a(nm,n)
      double precision x,y
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmhes,
c     num. math. 12, 349-368(1968) by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a real general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     low through igh to upper hessenberg form by
c     stabilized elementary similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the input matrix.
c
c     on output
c
c        a contains the hessenberg matrix.  the multipliers
c          which were used in the reduction are stored in the
c          remaining triangle under the hessenberg matrix.
c
c        int contains information on the rows and columns
c          interchanged in the reduction.
c          only elements low through igh are used.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
         mm1 = m - 1
         x = 0.0d0
         i = m
c
         do 100 j = m, igh
            if (dabs(a(j,mm1)) .le. dabs(x)) go to 100
            x = a(j,mm1)
            i = j
  100    continue
c
         int(m) = i
         if (i .eq. m) go to 130
c     .......... interchange rows and columns of a ..........
         do 110 j = mm1, n
            y = a(i,j)
            a(i,j) = a(m,j)
            a(m,j) = y
  110    continue
c
         do 120 j = 1, igh
            y = a(j,i)
            a(j,i) = a(j,m)
            a(j,m) = y
  120    continue
c     .......... end interchange ..........
  130    if (x .eq. 0.0d0) go to 180
         mp1 = m + 1
c
         do 160 i = mp1, igh
            y = a(i,mm1)
            if (y .eq. 0.0d0) go to 160
            y = y / x
            a(i,mm1) = y
c
            do 140 j = m, n
  140       a(i,j) = a(i,j) - y * a(m,j)
c
            do 150 j = 1, igh
  150       a(j,m) = a(j,m) + y * a(j,i)
c
  160    continue
c
  180 continue
c
  200 return
      end

      subroutine eltran(nm,n,low,igh,a,int,z)
c
      integer i,j,n,kl,mm,mp,nm,igh,low,mp1
      double precision a(nm,igh),z(nm,n)
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmtrans,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine accumulates the stabilized elementary
c     similarity transformations used in the reduction of a
c     real general matrix to upper hessenberg form by  elmhes.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the multipliers which were used in the
c          reduction by  elmhes  in its lower triangle
c          below the subdiagonal.
c
c        int contains information on the rows and columns
c          interchanged in the reduction by  elmhes.
c          only elements low through igh are used.
c
c     on output
c
c        z contains the transformation matrix produced in the
c          reduction by  elmhes.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
c     .......... initialize z to identity matrix ..........
      do 80 j = 1, n
c
         do 60 i = 1, n
   60    z(i,j) = 0.0d0
c
         z(j,j) = 1.0d0
   80 continue
c
      kl = igh - low - 1
      if (kl .lt. 1) go to 200
c     .......... for mp=igh-1 step -1 until low+1 do -- ..........
      do 140 mm = 1, kl
         mp = igh - mm
         mp1 = mp + 1
c
         do 100 i = mp1, igh
  100    z(i,mp) = a(i,mp-1)
c
         i = int(mp)
         if (i .eq. mp) go to 140
c
         do 130 j = mp, igh
            z(mp,j) = z(i,j)
            z(i,j) = 0.0d0
  130    continue
c
         z(i,mp) = 1.0d0
  140 continue
c
  200 return
      end

      subroutine hqr2(nm,n,low,igh,h,wr,wi,z,ierr)
c
      integer i,j,k,l,m,n,en,ii,jj,ll,mm,na,nm,nn,
     x        igh,itn,its,low,mp2,enm2,ierr
      double precision h(nm,n),wr(n),wi(n),z(nm,n)
      double precision p,q,r,s,t,w,x,y,ra,sa,vi,vr,zz,norm,tst1,tst2
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr2,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a real upper hessenberg matrix by the qr method.  the
c     eigenvectors of a real general matrix can also be found
c     if  elmhes  and  eltran  or  orthes  and  ortran  have
c     been used to reduce this general matrix to hessenberg form
c     and to accumulate the similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        h contains the upper hessenberg matrix.
c
c        z contains the transformation matrix produced by  eltran
c          after the reduction by  elmhes, or by  ortran  after the
c          reduction by  orthes, if performed.  if the eigenvectors
c          of the hessenberg matrix are desired, z must contain the
c          identity matrix.
c
c     on output
c
c        h has been destroyed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  the eigenvalues
c          are unordered except that complex conjugate pairs
c          of values appear consecutively with the eigenvalue
c          having the positive imaginary part first.  if an
c          error exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        z contains the real and imaginary parts of the eigenvectors.
c          if the i-th eigenvalue is real, the i-th column of z
c          contains its eigenvector.  if the i-th eigenvalue is complex
c          with positive imaginary part, the i-th and (i+1)-th
c          columns of z contain the real and imaginary parts of its
c          eigenvector.  the eigenvectors are unnormalized.  if an
c          error exit is made, none of the eigenvectors has been found.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      norm = 0.0d0
      k = 1
c     .......... store roots isolated by balanc
c                and compute matrix norm ..........
      do 50 i = 1, n
c
         do 40 j = k, n
   40    norm = norm + dabs(h(i,j))
c
         k = i
         if (i .ge. low .and. i .le. igh) go to 50
         wr(i) = h(i,i)
         wi(i) = 0.0d0
   50 continue
c
      en = igh
      t = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalues ..........
   60 if (en .lt. low) go to 340
      its = 0
      na = en - 1
      enm2 = na - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
   70 do 80 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 100
         s = dabs(h(l-1,l-1)) + dabs(h(l,l))
         if (s .eq. 0.0d0) s = norm
         tst1 = s
         tst2 = tst1 + dabs(h(l,l-1))
         if (tst2 .eq. tst1) go to 100
   80 continue
c     .......... form shift ..........
  100 x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (itn .eq. 0) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c     .......... form exceptional shift ..........
      t = t + x
c
      do 120 i = low, en
  120 h(i,i) = h(i,i) - x
c
      s = dabs(h(en,na)) + dabs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
  130 its = its + 1
      itn = itn - 1
c     .......... look for two consecutive small
c                sub-diagonal elements.
c                for m=en-2 step -1 until l do -- ..........
      do 140 mm = l, enm2
         m = enm2 + l - mm
         zz = h(m,m)
         r = x - zz
         s = y - zz
         p = (r * s - w) / h(m+1,m) + h(m,m+1)
         q = h(m+1,m+1) - zz - r - s
         r = h(m+2,m+1)
         s = dabs(p) + dabs(q) + dabs(r)
         p = p / s
         q = q / s
         r = r / s
         if (m .eq. l) go to 150
         tst1 = dabs(p)*(dabs(h(m-1,m-1)) + dabs(zz) + dabs(h(m+1,m+1)))
         tst2 = tst1 + dabs(h(m,m-1))*(dabs(q) + dabs(r))
         if (tst2 .eq. tst1) go to 150
  140 continue
c
  150 mp2 = m + 2
c
      do 160 i = mp2, en
         h(i,i-2) = 0.0d0
         if (i .eq. mp2) go to 160
         h(i,i-3) = 0.0d0
  160 continue
c     .......... double qr step involving rows l to en and
c                columns m to en ..........
      do 260 k = m, na
         notlas = k .ne. na
         if (k .eq. m) go to 170
         p = h(k,k-1)
         q = h(k+1,k-1)
         r = 0.0d0
         if (notlas) r = h(k+2,k-1)
         x = dabs(p) + dabs(q) + dabs(r)
         if (x .eq. 0.0d0) go to 260
         p = p / x
         q = q / x
         r = r / x
  170    s = dsign(dsqrt(p*p+q*q+r*r),p)
         if (k .eq. m) go to 180
         h(k,k-1) = -s * x
         go to 190
  180    if (l .ne. m) h(k,k-1) = -h(k,k-1)
  190    p = p + s
         x = p / s
         y = q / s
         zz = r / s
         q = q / p
         r = r / p
         if (notlas) go to 225
c     .......... row modification ..........
         do 200 j = k, n
            p = h(k,j) + q * h(k+1,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
  200    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 210 i = 1, j
            p = x * h(i,k) + y * h(i,k+1)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
  210    continue
c     .......... accumulate transformations ..........
         do 220 i = low, igh
            p = x * z(i,k) + y * z(i,k+1)
            z(i,k) = z(i,k) - p
            z(i,k+1) = z(i,k+1) - p * q
  220    continue
         go to 255
  225    continue
c     .......... row modification ..........
         do 230 j = k, n
            p = h(k,j) + q * h(k+1,j) + r * h(k+2,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
            h(k+2,j) = h(k+2,j) - p * zz
  230    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 240 i = 1, j
            p = x * h(i,k) + y * h(i,k+1) + zz * h(i,k+2)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
            h(i,k+2) = h(i,k+2) - p * r
  240    continue
c     .......... accumulate transformations ..........
         do 250 i = low, igh
            p = x * z(i,k) + y * z(i,k+1) + zz * z(i,k+2)
            z(i,k) = z(i,k) - p
            z(i,k+1) = z(i,k+1) - p * q
            z(i,k+2) = z(i,k+2) - p * r
  250    continue
  255    continue
c
  260 continue
c
      go to 70
c     .......... one root found ..........
  270 h(en,en) = x + t
      wr(en) = h(en,en)
      wi(en) = 0.0d0
      en = na
      go to 60
c     .......... two roots found ..........
  280 p = (y - x) / 2.0d0
      q = p * p + w
      zz = dsqrt(dabs(q))
      h(en,en) = x + t
      x = h(en,en)
      h(na,na) = y + t
      if (q .lt. 0.0d0) go to 320
c     .......... real pair ..........
      zz = p + dsign(zz,p)
      wr(na) = x + zz
      wr(en) = wr(na)
      if (zz .ne. 0.0d0) wr(en) = x - w / zz
      wi(na) = 0.0d0
      wi(en) = 0.0d0
      x = h(en,na)
      s = dabs(x) + dabs(zz)
      p = x / s
      q = zz / s
      r = dsqrt(p*p+q*q)
      p = p / r
      q = q / r
c     .......... row modification ..........
      do 290 j = na, n
         zz = h(na,j)
         h(na,j) = q * zz + p * h(en,j)
         h(en,j) = q * h(en,j) - p * zz
  290 continue
c     .......... column modification ..........
      do 300 i = 1, en
         zz = h(i,na)
         h(i,na) = q * zz + p * h(i,en)
         h(i,en) = q * h(i,en) - p * zz
  300 continue
c     .......... accumulate transformations ..........
      do 310 i = low, igh
         zz = z(i,na)
         z(i,na) = q * zz + p * z(i,en)
         z(i,en) = q * z(i,en) - p * zz
  310 continue
c
      go to 330
c     .......... complex pair ..........
  320 wr(na) = x + p
      wr(en) = x + p
      wi(na) = zz
      wi(en) = -zz
  330 en = enm2
      go to 60
c     .......... all roots found.  backsubstitute to find
c                vectors of upper triangular form ..........
  340 if (norm .eq. 0.0d0) go to 1001
c     .......... for en=n step -1 until 1 do -- ..........
      do 800 nn = 1, n
         en = n + 1 - nn
         p = wr(en)
         q = wi(en)
         na = en - 1
         if (q) 710, 600, 800
c     .......... real vector ..........
  600    m = en
         h(en,en) = 1.0d0
         if (na .eq. 0) go to 800
c     .......... for i=en-1 step -1 until 1 do -- ..........
         do 700 ii = 1, na
            i = en - ii
            w = h(i,i) - p
            r = 0.0d0
c
            do 610 j = m, en
  610       r = r + h(i,j) * h(j,en)
c
            if (wi(i) .ge. 0.0d0) go to 630
            zz = w
            s = r
            go to 700
  630       m = i
            if (wi(i) .ne. 0.0d0) go to 640
            t = w
            if (t .ne. 0.0d0) go to 635
               tst1 = norm
               t = tst1
  632          t = 0.01d0 * t
               tst2 = norm + t
               if (tst2 .gt. tst1) go to 632
  635       h(i,en) = -r / t
            go to 680
c     .......... solve real equations ..........
  640       x = h(i,i+1)
            y = h(i+1,i)
            q = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i)
            t = (x * s - zz * r) / q
            h(i,en) = t
            if (dabs(x) .le. dabs(zz)) go to 650
            h(i+1,en) = (-r - w * t) / x
            go to 680
  650       h(i+1,en) = (-s - y * t) / zz
c
c     .......... overflow control ..........
  680       t = dabs(h(i,en))
            if (t .eq. 0.0d0) go to 700
            tst1 = t
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 700
            do 690 j = i, en
               h(j,en) = h(j,en)/t
  690       continue
c
  700    continue
c     .......... end real vector ..........
         go to 800
c     .......... complex vector ..........
  710    m = na
c     .......... last vector component chosen imaginary so that
c                eigenvector matrix is triangular ..........
         if (dabs(h(en,na)) .le. dabs(h(na,en))) go to 720
         h(na,na) = q / h(en,na)
         h(na,en) = -(h(en,en) - p) / h(en,na)
         go to 730
  720    call cdiv(0.0d0,-h(na,en),h(na,na)-p,q,h(na,na),h(na,en))
  730    h(en,na) = 0.0d0
         h(en,en) = 1.0d0
         enm2 = na - 1
         if (enm2 .eq. 0) go to 800
c     .......... for i=en-2 step -1 until 1 do -- ..........
         do 795 ii = 1, enm2
            i = na - ii
            w = h(i,i) - p
            ra = 0.0d0
            sa = 0.0d0
c
            do 760 j = m, en
               ra = ra + h(i,j) * h(j,na)
               sa = sa + h(i,j) * h(j,en)
  760       continue
c
            if (wi(i) .ge. 0.0d0) go to 770
            zz = w
            r = ra
            s = sa
            go to 795
  770       m = i
            if (wi(i) .ne. 0.0d0) go to 780
            call cdiv(-ra,-sa,w,q,h(i,na),h(i,en))
            go to 790
c     .......... solve complex equations ..........
  780       x = h(i,i+1)
            y = h(i+1,i)
            vr = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i) - q * q
            vi = (wr(i) - p) * 2.0d0 * q
            if (vr .ne. 0.0d0 .or. vi .ne. 0.0d0) go to 784
               tst1 = norm * (dabs(w) + dabs(q) + dabs(x)
     x                      + dabs(y) + dabs(zz))
               vr = tst1
  783          vr = 0.01d0 * vr
               tst2 = tst1 + vr
               if (tst2 .gt. tst1) go to 783
  784       call cdiv(x*r-zz*ra+q*sa,x*s-zz*sa-q*ra,vr,vi,
     x                h(i,na),h(i,en))
            if (dabs(x) .le. dabs(zz) + dabs(q)) go to 785
            h(i+1,na) = (-ra - w * h(i,na) + q * h(i,en)) / x
            h(i+1,en) = (-sa - w * h(i,en) - q * h(i,na)) / x
            go to 790
  785       call cdiv(-r-y*h(i,na),-s-y*h(i,en),zz,q,
     x                h(i+1,na),h(i+1,en))
c
c     .......... overflow control ..........
  790       t = dmax1(dabs(h(i,na)), dabs(h(i,en)))
            if (t .eq. 0.0d0) go to 795
            tst1 = t
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 795
            do 792 j = i, en
               h(j,na) = h(j,na)/t
               h(j,en) = h(j,en)/t
  792       continue
c
  795    continue
c     .......... end complex vector ..........
  800 continue
c     .......... end back substitution.
c                vectors of isolated roots ..........
      do 840 i = 1, n
         if (i .ge. low .and. i .le. igh) go to 840
c
         do 820 j = i, n
  820    z(i,j) = h(i,j)
c
  840 continue
c     .......... multiply by transformation matrix to give
c                vectors of original full matrix.
c                for j=n step -1 until low do -- ..........
      do 880 jj = low, n
         j = n + low - jj
         m = min0(j,igh)
c
         do 880 i = low, igh
            zz = 0.0d0
c
            do 860 k = low, m
  860       zz = zz + z(i,k) * h(k,j)
c
            z(i,j) = zz
  880 continue
c
      go to 1001
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end

      subroutine balbak(nm,n,low,igh,scale,m,z)
c
      integer i,j,k,m,n,ii,nm,igh,low
      double precision scale(n),z(nm,m)
      double precision s
c
c     this subroutine is a translation of the algol procedure balbak,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine forms the eigenvectors of a real general
c     matrix by back transforming those of the corresponding
c     balanced matrix determined by  balanc.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by  balanc.
c
c        scale contains information determining the permutations
c          and scaling factors used by  balanc.
c
c        m is the number of columns of z to be back transformed.
c
c        z contains the real and imaginary parts of the eigen-
c          vectors to be back transformed in its first m columns.
c
c     on output
c
c        z contains the real and imaginary parts of the
c          transformed eigenvectors in its first m columns.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (m .eq. 0) go to 200
      if (igh .eq. low) go to 120
c
      do 110 i = low, igh
         s = scale(i)
c     .......... left hand eigenvectors are back transformed
c                if the foregoing statement is replaced by
c                s=1.0d0/scale(i). ..........
         do 100 j = 1, m
  100    z(i,j) = z(i,j) * s
c
  110 continue
c     ......... for i=low-1 step -1 until 1,
c               igh+1 step 1 until n do -- ..........
  120 do 140 ii = 1, n
         i = ii
         if (i .ge. low .and. i .le. igh) go to 140
         if (i .lt. low) i = low - ii
         k = scale(i)
         if (k .eq. i) go to 140
c
         do 130 j = 1, m
            s = z(i,j)
            z(i,j) = z(k,j)
            z(k,j) = s
  130    continue
c
  140 continue
c
  200 return
      end

      subroutine like(x1,xlag,beta,y1,nmax,icnt,alike)
C************************************************************************
C     PORPOSE: LIKELIHOOD ESTIMATION
C     INPUT: x1,xlag,beta,y1,nmax,ipmax,icnt,icol
C     OUTPUT: alike
C             IFAIL, MONITORING VALUE
C************************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION x1(nmax,*),xlag(nmax,*),y1(nmax,*),beta(*),x2(400,1)
      dimension x35(4,400),z0(400,4),x36(4,4)
      dimension zz0(4,4),zzz0(400,4),x37(4,400)
      dimension x38(4,2),x39(400,2),x40(400,2),x41(2,400)
      dimension x42(2,2),elp4(4,4),wk(2,2)
      EXTERNAL zeromat,multmat,trnmat,matinv,detmtx
c
      call zeromat(x2,400,icnt,1)
      call multmat(xlag,beta,x2,nmax,2,icnt,2,1)
      do 2 i=1,icnt
         z0(i,1)=x2(i,1)
         do 2 j=1,2
 2          z0(i,1+j)=x1(i,j)
      kk=3
      call trnmat(z0,x35,400,kk,icnt,kk)
      call multmat(x35,z0,x36,kk,400,kk,icnt,kk)
      call zeromat(zz0,4,4,4)
      call matinv(x36,zz0,elp4,kk,kk,ifail)
      call multmat(z0,zz0,zzz0,400,kk,icnt,kk,kk)
      call trnmat(zzz0,x37,400,kk,icnt,kk)
      call multmat(x37,y1,x38,kk,400,kk,icnt,2)
      call multmat(z0,x38,x39,400,kk,icnt,kk,2)
      call addmat(y1,x39,x40,400,icnt,2,-1)
      call trnmat(x40,x41,400,2,icnt,2)
      call multmat(x41,x40,x42,2,400,2,icnt,2)
      do 4 i=1,2
         do 4 j=1,2
 4          x42(i,j)=x42(i,j)/real(icnt)
      call detmtx(x42,wk,2,2,det)
      alike=(dble(icnt)/2.0)*dlog(det)
      return
      end

      subroutine cdiv(ar,ai,br,bi,cr,ci)
      double precision ar,ai,br,bi,cr,ci
c
c     complex division, (cr,ci) = (ar,ai)/(br,bi)
c
      double precision s,ars,ais,brs,bis
      s = dabs(br) + dabs(bi)
      ars = ar/s
      ais = ai/s
      brs = br/s
      bis = bi/s
      s = brs**2 + bis**2
      cr = (ars*brs + ais*bis)/s
      ci = (ais*brs - ars*bis)/s
      return
      end

      subroutine adf(dat,nmax,n,iadft,b1)
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension dat(nmax,*),data(400,10),diff(400),ac1(10),diff1(400)
      dimension sdm(10)
      external hushld,armfit,varcov
      do 2 i1=1,n
 2       diff(i1)=dat(i1,1)-b1*dat(i1,2)
      do 3 i1=1,n-1
 3       diff1(i1)=diff(i1+1)-diff(i1)
      do 1 i1=1,n-5
         data(i1,1)=1.0
         data(i1,2)=diff(i1+4)
         do 4 i2=1,4
 4          data(i1,2+i2)=diff1(i1+i2-1)
         data(i1,7)=diff1(i1+4)
 1    continue
      call HUSHLD(data,N-5,7,nmax)
      call ARMFIT(data,nmax,AC1,6,N-5,VA,IMIN,AC3,AC4)
      call VARCOV(data,nmax,imin,VA,SDM)
      iadft=0
      if (dabs(ac1(2)/sdm(2)).gt.3.4492) iadft=1      
      return
      end

      SUBROUTINE HUSHLD(AH1,N,K,IA11)
C===================================================================
C Purpose: HOUSHOLDER TRANSFORMATION
C Input : AH1 = array to be transformed;
C         N = number of columns;
C         K = number of rows;
C         IA11 = number of columns of AH1 in the calling program.
C Output: AH1 = transformed array.
C==================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AH1(IA11,*),Z(1000)
      TOL=1.0E-30
      NK=MIN0(N,K)
      DO 100 II=1,NK
      H=0.0
      DO 10 I=II,N
      Z(I) = AH1(I,II)
   10 H=H+Z(I)*Z(I)
      IF(H .GT. TOL) GOTO 40
      G=0.0
      GOTO 100
   40 G=SQRT(H)
      F=AH1(II,II)
      IF(F.GE.0.0) G=-G
      Z(II)=F-G
      H=H-F*G
      IF(II .EQ. K) GOTO 100
      II1=II+1
      DO 90 J=II1,NK
      S=0.0
      DO 20 I=II,N
   20 S=S+Z(I)*AH1(I,J)
      S=S/H
      DO 30 I=II,N
   30 AH1(I,J)=AH1(I,J)-Z(I)*S
   90 CONTINUE
  100 AH1(II,II)=G
      RETURN
      END

      SUBROUTINE ARMFIT(AH1,IA11,AC1,K,N,VA,IMIN,AC3,AC4)
C*******************************************************************
C Purpose: given the lags for different pieces, compute the AICC
C          for the AR-model in the Ith piece.
C Input: AH1 = housholder transformed array (so it is upper triangular);
C        IA11 = number of rows of AH1 in the calling program;
C        K = number of columns;
C        N = number of rows (number of data);
C        ISEL = indicator for information criterion.
C Output: AR(IMIN-1) = the chosen AR-model;
C         IMIN = the number parameters of the AR-model;
C         VA = mean sum of squared errors;
C         AC1 = contains the coefficients of the AR-model.
C Here, AC2 and AC3 are working vectors.
C===================================================================
C===================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AH1(IA11,*)
      DIMENSION AC1(*)
      K1=K+1
      K1=MIN0(N,K1)
      OSD=0.0E00
      FN=N
      OSD=OSD+AH1(K1,K1)*AH1(K1,K1)
      va=OSD/FN
      ac3=0.0
      ac4=0.0
c      AC3=FN*LOG(AC2)+((2*FN*(K+2))/(FN-K-3))
c      AC4=AC3+FN*LOG(REAL(FN/(FN-K-2)))
c      VA=AC2
      IMIN=K1-1
      IF(IMIN .EQ. 1) GOTO 200
      DO 100 M=IMIN,IMIN
         AC1(M)=AH1(M,K1)/AH1(M,M)
         MM1=M-1
         DO 110 II=1,MM1
            I=M-II
            SUM=DBLE(AH1(I,K1))
            I1=I+1
            DO 120 J=I1,M
  120       SUM=SUM-DBLE(AC1(J))*DBLE(AH1(I,J))
  110    AC1(I)=SUM/AH1(I,I)
  100 CONTINUE
      RETURN
  200 AC1(1)=AH1(1,K1)/AH1(1,1)
      RETURN
      END

      SUBROUTINE VARCOV(SAX,IAX,IMIN,VA,SDM)
C===================================================================
C===================================================================
C PURPOSE: TO PROVIDE THE VARIANCE COVARIANCE MATRIX FOR THE
C          ESTIMATES.
C INPUT: SAX=UPPER TRIANGULAR FORM OF THE DESIGN MATRIX
C        IAX=NO. OF COLUMNS OF SAX IN THE CALLING PROGRAM
C        IMIN: SAX IS OF DIMENSION IMIN BY IMIN
C        VA=SUM OF SQUARED ERRORS
C ACTION: THE SD ESTIMATES AND THE VARIANCE COVARIANCE MATRIX IS PRINTED
C SUBROUTINES CALLED: SINV
C===================================================================
C===================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SAX(IAX,*),SDM(*)
      DIMENSION TA(1000)
      EXTERNAL SINV
      IC=0
C     TO COMPRESS THE UPPER TRIANGULAR MATRIX SAX INTO ONE
C     DIMENSIONAL VECTOR TA
      DO 2 I2=1,IMIN
      DO 2 I1=1,I2
      IC=IC+1
    2 TA(IC)=SAX(I1,I2)
C     CALCULATE VA*INVERSE OF THE PRODUCT OF SAX TRANSPOSE AND SAX
      CALL SINV(TA,IMIN,VA)   
C     RETIREVE THE DIAGONAL AND TAKE THE SQUARE ROOT; THEY ARE
C     ESTIMATES OF STANDARD ERROR
      I=1
      IP=1
 11   SDM(I)=SQRT(TA(IP))
      I=I+1
      IP=I+IP
      IF(I .GT. IMIN) GOTO 10
      GOTO 11
  10  RETURN
      END      
      
      SUBROUTINE SINV(A,N,VA)
C===================================================================
C===================================================================
C PURPOSE: TO PROVIDE THE PRODUCT OF THE INVERSE A'*A AND VA
C INPUT: A THE UPPER TRIANGULAR MATRIX STACKED UP ROW-WISE
C        N=DIMENSION OF THE TRIANGULAR MATRIX,SO N*(N-1)=LENGTH OF A
C        VA=MEAN SUM OF SQUARE ERROR
C OUTPUT: A=THE DESIRED PRODUCT AS DESCRIBED IN THE PURPOSE
C===================================================================
C===================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1000)
      IPIV=N*(N+1)/2
      IND=IPIV
      DO 6 I=1,N
      DIN=1.D0/DBLE(A(IPIV))
      A(IPIV)=DIN
      MIN=N
      KEND=I-1
      LANF=N-KEND
      IF(KEND) 5,5,2
    2 J=IND
      DO 4 K=1,KEND
      WORK=0.D0
      MIN=MIN-1
      LHOR=IPIV
      LVER=J
      DO 3 L=LANF,MIN
      LVER=LVER+1
      LHOR=LHOR+L
    3 WORK=WORK+DBLE(A(LVER)*A(LHOR))
      A(J)=-WORK*DIN
    4 J=J-MIN
    5 IPIV=IPIV-MIN
    6 IND=IND-1
      DO 8 I=1,N
      IPIV=IPIV+I
      J=IPIV
      DO 8 K=I,N
      WORK=0.D0
      LHOR=J
      DO 7 L=K,N
      LVER=LHOR+K-I
      WORK=WORK+DBLE(A(LHOR)*A(LVER))
    7 LHOR=LHOR+L
      A(J)=WORK*DBLE(VA)
    8 J=J+K
      RETURN
      END      
