ccccc This program is intended for nonlinear error correction models
c     It checks the estimation power of OLS method for (L)TVECM,
c     Created on August 2001 by Antoni Vidiella
c     modified in December 2002 (Annals of Econometrics)
c     GRID SEARCH
c
c     Current setting
c
c     Number-variables = 2
c     max-obs  = 400
c     max-number of regimes = 2
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      parameter(nmax=400,ipmax=5)
      dimension dat(nmax,ipmax),rnn(ipmax),elp2(ipmax,ipmax)
      dimension dat2(nmax,ipmax),dat3(nmax,ipmax),dat4(nmax,ipmax)
      dimension y1(nmax,ipmax),x1(nmax,ipmax),x2(ipmax,nmax)
      dimension x3(ipmax,ipmax),x4(ipmax,ipmax),x5(nmax,ipmax)
      dimension x6(ipmax,2),x7(nmax,2),x8(nmax,2),zj(nmax,ipmax)
      dimension elp1(ipmax,ipmax),hreg(ipmax,ipmax,2)
      dimension bcan(1000),post(1000),x18(nmax,2)
      dimension desv1(ipmax),c1(ipmax),w(nmax),z(nmax,ipmax)
      dimension det1(1000,1000),x9(ipmax,ipmax),x10(nmax,ipmax)
      dimension ri(400),x41(ipmax,2),var(ipmax),cn(ipmax,ipmax)
      dimension x43(ipmax,2),dat5(1000+nmax,ipmax),d1(nmax)
      dimension err1(1000),h1(ipmax,ipmax),wk(2,2)
      dimension zzj(nmax,ipmax),zzj1(ipmax,nmax),x11(ipmax,ipmax)
      dimension x12(ipmax,ipmax),x13(ipmax,2),x14(ipmax,2)
      dimension x15(nmax,2),x16(2,nmax),x17(2,2)
      dimension d8(nmax,2),d9(nmax,2),c2(ipmax),c3(ipmax)
      dimension desv2(ipmax),desv3(ipmax),w2(nmax)
      dimension dat8(nmax,ipmax),beta3(2),c4(ipmax)
c
      integer seed
      intrinsic amin1
c
c
ccccc Introduction of data
c
      open (10,file='olsf12.res',status='unknown')
c      seed=123456789
      irun=2000
      is=1
      icnt=0
      ip=2
      nob=400
      ierr=0
      trim=0.1
      sig=10.0
      iprec=2
      b1=1.5
      a1=0.0
      a2=-1.0
      theta=0.0
      sigma=2.0
      do 153 ia=1,2
           do 153 i=1,2
              do 153 j=1,2
 153           hreg(i,j,ia)=0.0
      hreg(1,1,1)=-0.8
      hreg(1,2,1)=1.6
      hreg(1,3,1)=0.0      
      hreg(2,1,1)=0.0      
      hreg(2,2,1)=0.0
      hreg(2,3,1)=0.0 
      hreg(1,1,2)=-0.8
      hreg(1,2,2)=0.8
      hreg(1,3,2)=0.0      
      hreg(2,1,2)=0.0
      hreg(2,2,2)=0.0
      hreg(2,3,2)=0.0
      beta3(1)=2.0
      beta3(2)=1.0            
      err=0.0
      call zeromat(x41,ipmax,ipmax,2)               
      do 930 iv=1,irun      
 821  continue
         dat5(1,1)=0.0
         dat5(1,2)=0.0
         call zerovec(var,ipmax,ipmax)
         do 192 ik=1,nob+20
            do 194 j=1,2
               if (ik.gt.1) dat5(ik,j)=dat5(ik-1,j)+var(j)
 194        continue
            err=dat5(ik,1)-b1*dat5(ik,2)
            ia=1
            if(err.gt.0.0) ia=2
            d=(a1*beta3(ia)-a2)
            do 196 j=1,2
               x41(j,1)=dat5(ik,j)
               x41(j,2)=dat5(ik,j)
 196           x41(3,j)=var(j)
            call zerovec(var,ipmax,ipmax)
            CALL ZEROVEC(RI,400,10)
            CALL GNORM(RI,2,SEED)
            ezt=ri(1)
            ewt=ri(1)*theta*sigma+ri(2)*sqrt((sigma**2)-
     1          (theta*sigma)**2)
            rnn(1)=(1/d)*(-a2*ezt+beta3(ia)*ewt)
            rnn(2)=(1/d)*(-a1*ezt+ewt)
c            rnn(1)=ri(1)
c            rnn(2)=ri(2)
            do 161 i=1,2
               do 161 j=1,3
 161              h1(i,j)=hreg(i,j,ia)
            call zeromat(x43,ipmax,ipmax,2)
            call multmat(h1,x41,x43,ipmax,ipmax,2,3,2)
            do 197 j=1,2
 197           var(j)=x43(j,j)+rnn(j)
               call zeromat(x41,ipmax,ipmax,2)               
               call zerovec(rnn,ipmax,ipmax)
 192        continue
            do 193 i=21,nob+20
               do 193 j=1,2
 193              dat(i-20,j)=dat5(i,j)
c            do 198 i=1,nob
c 198           write(10,*) (dat(i,j),j=1,2)
            icount9=0
            isgn=0
            sgn1=0.0
            do 199 i=1,nob
 199           if((dat(i,1)-b1*dat(i,2)).gt.0.0) icount9=icount9+1            
             call eqmat(dat,dat8,nmax,nmax,nob,2)
             call adf(dat8,nmax,nob,iadft,b1)
            sgn1=real(icount9)/real(nob)
            if((sgn1.lt.0.45).or.((1.0-sgn1).lt.0.45)) isgn=1
            if (iadft.eq.0.or.isgn.eq.1) goto 821
            call zeromat(dat5,1000+nmax,1000+nob,ipmax)
            call zeromat(dat4,nmax,nob,ipmax)
            call zeromat(dat2,nmax,nob,ipmax)
            call zeromat(dat3,nmax,nob,ipmax)
          call reg(dat8,nmax,nob,c4,desv2,0) 
c in dat we have the simulated set of data, dat(i,j)
c begin of the threshold search
          inam=10**iprec+1
          if (ierr.eq.1) then
              call zerovec(c1,ipmax,ipmax)
              call zerovec(desv1,ipmax,ipmax)
              call reg(dat,nmax,nob,c1,desv1,0)
              call zerovec(bcan,1000,nob)
              upl=0.0
              bol=0.0
              upl=c1(1)+sig*desv1(1)
              bol=c1(1)-sig*desv1(1)
              step=(upl-bol)/real(10**iprec)
              bcan(1)=bol
              do 45 im=2,10**iprec+1
 45             bcan(im)=bcan(im-1)+step
         else
              inam=1
              bcan(1)=1.5
              c1(1)=bcan(1)
         endif            
         call zerovec(err1,1000,nob)
         do 44 it=1, nob
 44         err1(it)=dat(it,1)-c1(1)*dat(it,2)
         call zerovec(post,1000,nob)
         ipa=400
         if (is.eq.0) then
              CALL QCKSRT(nob,err1)
              up=0.0
              bo=0.0
              up=err1(nob)
              bo=err1(1)
              step=0.0
              step=(up-bo)/real(ipa)
              post(1)=bo
              do 49 im=2,ipa
 49                post(im)=post(im-1)+step
         else if(is.eq.1) then
            ipa=0
            call pcand(err1,nob,post,trim,1-trim,ipa)
         else if(is.eq.2) then
            open(17,file='cand.dat',status='unknown')         
            do 491 ii=1,ipa
 491           read(17,*) post(ii)
         else if(is.eq.3) then
            ipa=1
            post(1)=0.0
         endif
         do 60 i=1,nob-ip
c              x1(i,1)=1.0
              do 610 j=1,ip-1 
                 do 610 k=1,2
 610              x1(i,k+2*(j-1))=dat(ip+i-j,k)-dat(ip+i-j-1,k)
 60      continue
         do 70 i=ip,nob-1
           do 70 j=1,2
 70            y1(i-ip+1,j)=dat(i+1,j)-dat(i,j)
      icnt=nob-ip
      ior=(ip-1)*2
      call zeromat(x4,ipmax,ipmax,ipmax)
      call trnmat(x1,x2,nmax,ipmax,icnt,ior)
      call multmat(x2,x1,x3,ipmax,nmax,ior,icnt,ior)
      call matinv(x3,x4,elp1,ipmax,ior,ifail)      
      call multmat(x1,x4,x5,nmax,ipmax,icnt,ior,ior)
      call multmat(x2,y1,x6,ipmax,nmax,ior,icnt,2)
      call multmat(x5,x6,x7,nmax,ipmax,icnt,ior,2)
      call addmat(y1,x7,x8,nmax,icnt,2,-1)
      call zeromat(det1,1000,1000,1000)
      do 900 ix=1,ipa
c     iz is the index for the cointegration parameter
         do 910 iz=1,inam 
            do 47 i=1,icnt
               w(i)=dat(i+1,1)-bcan(iz)*dat(i+1,2)
c               write(6,*) w(i)
               z(i,1)=w(i)
               do 47 k=1,ior
 47               z(i,1+k)=x1(i,k)
            a11=0.0
            call zerovec(d1,nmax,icnt)
            do 100 it = 1,icnt
               if(w(it).le.post(ix)) d1(it)=1.0
 100           a11=a11+d1(it)   
c               write(10,*) dmin1((a11/dble(nob)),(nob-a11)/dble(nob)),trim
            if (dmin1((a11/dble(nob)),(nob-a11)/dble(nob)).gt.trim) then
               do 110 i=1,icnt
                  do 120 j=1,1+ior
 120                 zj(i,j)=z(i,j)*d1(i)
 110              zj(i,2+ior)=w(i)
                  call multmat(x2,zj,x9,ipmax,nmax,ior,icnt,2+ior)
                  call multmat(x5,x9,x10,nmax,ipmax,icnt,ior,2+ior)                  
                  call addmat(zj,x10,zzj,nmax,icnt,2+ior,-1)
                  call trnmat(zzj,zzj1,nmax,ipmax,icnt,2+ior)
                  call multmat(zzj1,zzj,x11,ipmax,nmax,ior+2,icnt,ior+2)
                  call zeromat(x12,ipmax,ipmax,ipmax)
                  call matinv(x11,x12,elp2,ipmax,ior+2,ifail)      
                  call multmat(zzj1,x8,x13,ipmax,nmax,ior+2,icnt,2)
                  call multmat(x12,x13,x14,ipmax,ipmax,ior+2,ior+2,2)
                  call multmat(zzj,x14,x15,nmax,ipmax,icnt,ior+2,2)
                  call addmat(x8,x15,x18,nmax,icnt,2,-1)
                  call trnmat(x18,x16,nmax,2,icnt,2)
                  call multmat(x16,x18,x17,2,nmax,2,icnt,2)
                  do 130 i=1,2
                     do 130 j=1,2
 130                    x17(i,j)=x17(i,j)/real(icnt)
                  det=0.0
                  call zeromat(wk,2,2,2)
                  call detmtx(x17,wk,2,2,det)
                  det1(iz,ix)=(real(icnt)/2.0)*dlog(dble(det))
                  call zeromat(zj,nmax,nob,ipmax)
                  call zerovec(w,nmax,nob)
                  call zeromat(z,nmax,nob,ipmax)
                  call zeromat(x16,2,2,nob)
                  call zeromat(x17,2,2,2)
                  call zeromat(x12,ipmax,ipmax,ipmax)
                  call zeromat(x13,ipmax,ipmax,2)
                  call zeromat(x11,ipmax,ipmax,ipmax)
                  call zeromat(x14,ipmax,ipmax,2)
                  call zeromat(x9,ipmax,ipmax,ipmax)
                  call zeromat(x15,nmax,nob,2)
                  call zeromat(x18,nmax,nob,2)
                  call zeromat(x10,nmax,ipmax,ipmax)
                  call zeromat(zzj,nmax,nob,ipmax)
                  call zeromat(zzj1,ipmax,ipmax,nob)
                  call zeromat(elp1,ipmax,ipmax,ipmax)
                else
                  det1(iz,ix)=9.d+10
                endif
c              write(6,*) det1(1,ix),ix
 910        continue
 900     continue
         ibm=1
         itm=1
         detmin=det1(1,1)
         do 920 i=1,inam
           do 920 j=1,ipa
              if (det1(i,j).lt.detmin) then
                 detmin=det1(i,j)
                 ibm=i
                 itm=j
              endif
 920     continue
         write(6,508) post(itm),bcan(ibm)
         do 800 i=1,nob-1
 800        w2(i)=dat(i,1)-bcan(ibm)*dat(i,2)
         n2=0
         n3=0
         do 810 i=2,nob
            if(w2(i-1).le.post(itm)) then
                  n2=n2+1
               do 820 j=1,2
                  d8(n2,j)=dat(i,j)                  
 820           continue
            else
                  n3=n3+1
               do 830 j=1,2
 830              d9(n3,j)=dat(i,j)
               continue
            endif
 810     continue
c         do 893 i3=1,n2
c 893        write(10,*) (d8(i3,i4),i4=1,2)
c         write(10,*)
c         do 894 i3=1,n3
c 894        write(10,*) (d9(i3,i4),i4=1,2)
         call reg(d8,nmax,n2,c2,desv2,0)
         call reg(d9,nmax,n3,c3,desv3,0)
         write(10,508) post(itm),bcan(ibm),c2(1),c3(1),c4(1)
         write(6,*) c2(1),c3(1),iv
         call zeromat(d8,nmax,n2,2)
         call zeromat(d9,nmax,n3,2)
         call zeromat(y1,nmax,nob,ipmax)
         call zeromat(x1,nmax,nob,ipmax)
         call zeromat(x2,ipmax,ipmax,nob)
         call zeromat(x3,ipmax,ipmax,ipmax)
         call zeromat(x4,ipmax,ipmax,ipmax)
         call zeromat(x5,nmax,nob,ipmax)
         call zeromat(x6,ipmax,ipmax,2)
         call zeromat(x7,nmax,nob,2)
         call zeromat(x8,nmax,nob,2)
         call zeromat(dat,nmax,nob,ipmax)
         call zeromat(dat8,nmax,nob,ipmax)
 930  continue
 508   format(5f10.5)
      end       

      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      call zeromat(cmat,id1max,l1,l3)
      DO 99 J=1,L3
         DO 98 K=1,L2
            IF (BMAT(K,J).EQ.0.0) GOTO 98
            DO 97 I=1,L1
               CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END

      SUBROUTINE MATINV(AMAT,BMAT,ELP,ID1MAX,L1,IFAIL)
C************************************************************************
C     PORPOSE: MATRIX INVERSION
C     INPUT: AMAT, MATRIX DIMENSION L1,L1
C     OUTPUT: BMAT, MATRIX DIMENSION L1,L1
C             IFAIL, MONITORING VALUE
C************************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),ELP(ID1MAX,*)
C     
      CALL ZEROMAT(ELP,ID1MAX,L1,L1)
      CALL EQMAT(AMAT,ELP,ID1MAX,ID1MAX,L1,L1)
      DO 115 I=1,L1
         BMAT(I,I)=1.0
  115 CONTINUE
      DO 99 J=1,L1
         DO 98 I=J,L1
            IF (ELP(I,J).NE.0.0) GOTO 11
   98    CONTINUE
         IFAIL=1
         RETURN
   11    CONTINUE
      DO 97 K=1,L1
C
         PIVOT01= ELP(J,K)
         ELP(J,K)= ELP(I,K)
         ELP(I,K)= PIVOT01
C
         PIV= BMAT(J,K)
         BMAT(J,K)=BMAT(I,K)
         BMAT(I,K)= PIV
   97 CONTINUE
C
      IF(ELP(J,J).NE.0.0) GOTO 22
C
      IFAIL=1
      RETURN
C
C
   22 CONTINUE
      PPP= 1.0/ELP(J,J)
      DO 96 K=1,L1
C
         ELP(J,K)= ELP(J,K)*PPP
         BMAT(J,K)= BMAT(J,K)*PPP
   96 CONTINUE
C
      DO 95 K=1,L1
C
         IF(J.EQ.K) THEN
C
   33       CONTINUE
C
         ELSE
            PPP= ELP(K,J)
            DO 94 L=1,L1
C
               ELP(K,L)=ELP(K,L)-ELP(J,L)*PPP
               BMAT(K,L)=BMAT(K,L)-BMAT(J,L)*PPP
   94       CONTINUE
C
         END IF
   95 CONTINUE
   99 CONTINUE
C
      RETURN
      END

     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
         DO 99 I=1,L1
            AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
        DIMENSION VEC(ID1MAX)

      DO 98 I=1,L1     
                VEC(I)=0.0
  98  CONTINUE
      RETURN
        END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
      external zeromat
      call zeromat(bmat,id2max,l1,l2)
      DO 98 J=1,L2
         DO 99 I=1,L1
            BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END

      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
            VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END

      SUBROUTINE TRNMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C********************************************************************
C     PORPOSE: TRANSPOSE A MATRIX OF DIMENSION L1,L2
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: BMAT, TRANSPOSED MATRIX DIMENSION L2,L1
C********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
      external zeromat
      call zeromat(bmat,id2max,l2,l1)
      DO 98 J=1,L2
         DO 99 I=1,L1
            BMAT(J,I)=AMAT(I,J)
   99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      CALL ZEROMAT(CMAT,ID1MAX,L1,L2)
      DO 2 J=1,L1
         DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END

      SUBROUTINE reg(dat,ID1MAX,nob,coef,desv,icf)
C**********************************************************************
C     PORPOSE: OLS ESTIMATES (NON RESTRICTED)
C**********************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION dat(ID1MAX,*),coef(*),dat1(400,3),dat2(3,400),dat3(3,3)
      dimension dat4(3,3),dat5(3,400),y(400,1),elp2(3,3),desv(*)
      dimension dat6(400,3)
      external multmat,matinv,trnmat,zeromat,zerovec
      s1=0.0
      s2=0.0
      s3=0.0
      call zeromat(dat1,400,400,3)
      call zeromat(dat2,3,3,400)
      call zeromat(dat3,3,3,3)
      call zeromat(dat4,3,3,3)
      call zeromat(dat5,3,3,400)
      call zerovec(coef,3,3)
      call zerovec(desv,3,3)
      call zeromat(dat6,400,400,3)
      call zeromat(y,400,400,1)
      do 100 i=1,nob
         y(i,1)=dat(i,1)
         if (icf.eq.1) dat1(i,1)=1.0
 100     dat1(i,1+icf)=dat(i,2)
      call trnmat(dat1,dat2,400,3,nob,1+icf)
      call multmat(dat2,dat1,dat3,3,400,1+icf,nob,1+icf)
      call matinv(dat3,dat4,elp2,3,1+icf,ifail)
      call multmat(dat4,dat2,dat5,3,3,1+icf,1+icf,nob)
      call multmat(dat5,y,coef,3,400,1+icf,nob,1)
      err=0.0
      call multmat(dat1,coef,dat6,400,3,nob,1+icf,1)
      do 110 i=1,nob
 110     err=err+(y(i,1)-dat6(i,1))**2
      xse=err/real(nob-(1+icf))
      do 120 i=1,icf+1
 120    desv(i)=sqrt(dat4(i,i)*xse)      
      end

      SUBROUTINE PCAND(X,N,CTHD,IPL,IPU,IPR)
C**************************************************************
C DEFINES CANDIDATE THRESHOLD VALUES FOR INFLATION RATES
C THRESHOLD VALUES ARE SEARCHED AMONG THE INTERPERCENTILE RANGE
C @ EQUIWIDTH INTERVALS ( # INTERVALS = # VALUES BETWEEN PERC)
C X = MATRIX OF DATA
C N = # DATA
C CTHD = ARRAY OF CANDIDATE THRESHOLD VALUES
C IPL = USER-SUPPLIED LOWER PERCENTILE
C IPU = USER-SUPPLIED UPPER PERCENTILE
C EXTERNAL SUBROUTINE = QCKSRT
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 IPL,IPU
      DIMENSION X(*),CTHD(*),SARR(1000)
      EXTERNAL QCKSRT
      DO 12 I=1,N
 12      SARR(I)=X(I)
      CALL QCKSRT(N,SARR)
      IP1=NINT(IPL*N)
      AMIN=SARR(IP1)
      IP2=NINT(IPU*N)
      AMAX=SARR(IP2)
      IPR=IP2-IP1
      AI=AMAX-AMIN
      AINC=AI/REAL(IPR)
      CTHD(1)=AMIN
      DO 13 J=2,IPR
 13      CTHD(J)=CTHD(J-1)+AINC
      RETURN
      END

C#####################################################
C Quicksort routine from numerical recipes
C#####################################################
      SUBROUTINE QCKSRT(N,ARR)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (M=7,NSTACK=50,FM=7875.,FA=211.,FC=1663.
     *    ,FMI=1.2698413E-4,maxdat=1000)
      DIMENSION ISTACK(NSTACK)
      DIMENSION ARR(maxdat)
C     DOUBLE PRECISION A
      JSTACK=0
      L=1
      IR=N
      FX=0.
10    IF(IR-L.LT.M)THEN
        DO 13 J=L+1,IR
          A=ARR(J)
          DO 11 I=J-1,1,-1
            IF(ARR(I).LE.A)GO TO 12
            ARR(I+1)=ARR(I)
11        CONTINUE
          I=0
12        ARR(I+1)=A
13      CONTINUE
        IF(JSTACK.EQ.0)RETURN
        IR=ISTACK(JSTACK)
        L=ISTACK(JSTACK-1)
        JSTACK=JSTACK-2
      ELSE
        I=L
        J=IR
        FX=MOD(FX*FA+FC,FM)
        IQ=L+(IR-L+1)*(FX*FMI)
        A=ARR(IQ)
        ARR(IQ)=ARR(L)
20      CONTINUE
21        IF(J.GT.0)THEN
            IF(A.LT.ARR(J))THEN
              J=J-1
              GO TO 21
            ENDIF
          ENDIF
          IF(J.LE.I)THEN
            ARR(I)=A
            GO TO 30
          ENDIF
          ARR(I)=ARR(J)
          I=I+1
22        IF(I.LE.N)THEN
            IF(A.GT.ARR(I))THEN
              I=I+1
              GO TO 22
            ENDIF
          ENDIF
          IF(J.LE.I)THEN
            ARR(J)=A
            I=J
            GO TO 30
          ENDIF
          ARR(J)=ARR(I)
          J=J-1
        GO TO 20
30      JSTACK=JSTACK+2
        IF(JSTACK.GT.NSTACK)PAUSE 'NSTACK must be made larger.'
        IF(IR-I.GE.I-L)THEN
          ISTACK(JSTACK)=IR
          ISTACK(JSTACK-1)=I+1
          IR=I-1
        ELSE
          ISTACK(JSTACK)=I-1
          ISTACK(JSTACK-1)=L
          L=I+1
        ENDIF
      ENDIF
      GO TO 10
      END

       subroutine gnorm(r,nr,rs)
       implicit double precision (a-h,o-z)
       integer nr,rs
       dimension r(*)
       do  1 i=1,nr
99        continue         
          v=random()*2.-1.
          u=random()*2.-1.
          w=v*v+u*u
          if(w.gt.1.)goto 99
          c=dsqrt(-2.*dlog(w)/w)
          R(i)=c*v
          r(i+1)=c*u
1      continue
       return
       end                      
       
       subroutine date_time_seed@
       end            
       
C

c*****************************************
       subroutine detmtx(a,wk,mx,k,det)
c
c---- This program computes the determinant of a covariance matrix.
c     It assumes that the variance of each variable is not close to zero.
c     The program transforms the mtx into an upper triangular one.
c
       real*8 a(mx,mx), det, tem, wk(mx,mx), crit
       integer mx, k, i, j, km1
c--------- wk(.,.) is a working area.
c
       if(k.eq.1)then
        det = a(1,1)
        return
       endif
c
       km1 = k-1
       crit = 1.0d-15
c
       do 10 i=1, k
        do 10 j=1, k
 10        wk(i,j) = a(i,j)
c
       do 50 i=1, km1
        if(dabs(a(i,i)).le.crit)then 
         det = 0.0d0
         return
        endif
        tem = wk(i+1,i)/a(i,i)
        do 40 j=i+1, k
 40       wk(i+1,j) = wk(i+1,j)-wk(i,j)*tem
 50      continue
c
       det = 1.0d0
       do 60 i=1, k
 60       det = det*wk(i,i)
c
cc       print*,'det = ', det
c
       return
       end

      subroutine adf(dat,nmax,n,iadft,b1)
      IMPLICIT REAL*8 (A-H,O-Z)
      dimension dat(nmax,*),data(400,10),diff(400),ac1(10),diff1(400)
      dimension sdm(10)
      external hushld,armfit,varcov
      do 2 i1=1,n
 2       diff(i1)=dat(i1,1)-b1*dat(i1,2)
      do 3 i1=1,n-1
 3       diff1(i1)=diff(i1+1)-diff(i1)
      do 1 i1=1,n-5
         data(i1,1)=1.0
         data(i1,2)=diff(i1+4)
         do 4 i2=1,4
 4          data(i1,2+i2)=diff1(i1+i2-1)
         data(i1,7)=diff1(i1+4)
 1    continue
      call HUSHLD(data,N-5,7,nmax)
      call ARMFIT(data,nmax,AC1,6,N-5,VA,IMIN,AC3,AC4)
      call VARCOV(data,nmax,imin,VA,SDM)
      iadft=0
      if (dabs(ac1(2)/sdm(2)).gt.3.4492) iadft=1      
      return
      end

      SUBROUTINE HUSHLD(AH1,N,K,IA11)
C===================================================================
C Purpose: HOUSHOLDER TRANSFORMATION
C Input : AH1 = array to be transformed;
C         N = number of columns;
C         K = number of rows;
C         IA11 = number of columns of AH1 in the calling program.
C Output: AH1 = transformed array.
C==================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AH1(IA11,*),Z(1000)
      TOL=1.0E-30
      NK=MIN0(N,K)
      DO 100 II=1,NK
      H=0.0
      DO 10 I=II,N
      Z(I) = AH1(I,II)
   10 H=H+Z(I)*Z(I)
      IF(H .GT. TOL) GOTO 40
      G=0.0
      GOTO 100
   40 G=SQRT(H)
      F=AH1(II,II)
      IF(F.GE.0.0) G=-G
      Z(II)=F-G
      H=H-F*G
      IF(II .EQ. K) GOTO 100
      II1=II+1
      DO 90 J=II1,NK
      S=0.0
      DO 20 I=II,N
   20 S=S+Z(I)*AH1(I,J)
      S=S/H
      DO 30 I=II,N
   30 AH1(I,J)=AH1(I,J)-Z(I)*S
   90 CONTINUE
  100 AH1(II,II)=G
      RETURN
      END

      SUBROUTINE ARMFIT(AH1,IA11,AC1,K,N,VA,IMIN,AC3,AC4)
C*******************************************************************
C Purpose: given the lags for different pieces, compute the AICC
C          for the AR-model in the Ith piece.
C Input: AH1 = housholder transformed array (so it is upper triangular);
C        IA11 = number of rows of AH1 in the calling program;
C        K = number of columns;
C        N = number of rows (number of data);
C        ISEL = indicator for information criterion.
C Output: AR(IMIN-1) = the chosen AR-model;
C         IMIN = the number parameters of the AR-model;
C         VA = mean sum of squared errors;
C         AC1 = contains the coefficients of the AR-model.
C Here, AC2 and AC3 are working vectors.
C===================================================================
C===================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AH1(IA11,*)
      DIMENSION AC1(*)
      K1=K+1
      K1=MIN0(N,K1)
      OSD=0.0E00
      FN=N
      OSD=OSD+AH1(K1,K1)*AH1(K1,K1)
      va=OSD/FN
      ac3=0.0
      ac4=0.0
c      AC3=FN*LOG(AC2)+((2*FN*(K+2))/(FN-K-3))
c      AC4=AC3+FN*LOG(REAL(FN/(FN-K-2)))
c      VA=AC2
      IMIN=K1-1
      IF(IMIN .EQ. 1) GOTO 200
      DO 100 M=IMIN,IMIN
         AC1(M)=AH1(M,K1)/AH1(M,M)
         MM1=M-1
         DO 110 II=1,MM1
            I=M-II
            SUM=DBLE(AH1(I,K1))
            I1=I+1
            DO 120 J=I1,M
  120       SUM=SUM-DBLE(AC1(J))*DBLE(AH1(I,J))
  110    AC1(I)=SUM/AH1(I,I)
  100 CONTINUE
      RETURN
  200 AC1(1)=AH1(1,K1)/AH1(1,1)
      RETURN
      END

      SUBROUTINE VARCOV(SAX,IAX,IMIN,VA,SDM)
C===================================================================
C===================================================================
C PURPOSE: TO PROVIDE THE VARIANCE COVARIANCE MATRIX FOR THE
C          ESTIMATES.
C INPUT: SAX=UPPER TRIANGULAR FORM OF THE DESIGN MATRIX
C        IAX=NO. OF COLUMNS OF SAX IN THE CALLING PROGRAM
C        IMIN: SAX IS OF DIMENSION IMIN BY IMIN
C        VA=SUM OF SQUARED ERRORS
C ACTION: THE SD ESTIMATES AND THE VARIANCE COVARIANCE MATRIX IS PRINTED
C SUBROUTINES CALLED: SINV
C===================================================================
C===================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION SAX(IAX,*),SDM(*)
      DIMENSION TA(1000)
      EXTERNAL SINV
      IC=0
C     TO COMPRESS THE UPPER TRIANGULAR MATRIX SAX INTO ONE
C     DIMENSIONAL VECTOR TA
      DO 2 I2=1,IMIN
      DO 2 I1=1,I2
      IC=IC+1
    2 TA(IC)=SAX(I1,I2)
C     CALCULATE VA*INVERSE OF THE PRODUCT OF SAX TRANSPOSE AND SAX
      CALL SINV(TA,IMIN,VA)   
C     RETIREVE THE DIAGONAL AND TAKE THE SQUARE ROOT; THEY ARE
C     ESTIMATES OF STANDARD ERROR
      I=1
      IP=1
 11   SDM(I)=SQRT(TA(IP))
      I=I+1
      IP=I+IP
      IF(I .GT. IMIN) GOTO 10
      GOTO 11
  10  RETURN
      END      
      
      SUBROUTINE SINV(A,N,VA)
C===================================================================
C===================================================================
C PURPOSE: TO PROVIDE THE PRODUCT OF THE INVERSE A'*A AND VA
C INPUT: A THE UPPER TRIANGULAR MATRIX STACKED UP ROW-WISE
C        N=DIMENSION OF THE TRIANGULAR MATRIX,SO N*(N-1)=LENGTH OF A
C        VA=MEAN SUM OF SQUARE ERROR
C OUTPUT: A=THE DESIRED PRODUCT AS DESCRIBED IN THE PURPOSE
C===================================================================
C===================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(1000)
      IPIV=N*(N+1)/2
      IND=IPIV
      DO 6 I=1,N
      DIN=1.D0/DBLE(A(IPIV))
      A(IPIV)=DIN
      MIN=N
      KEND=I-1
      LANF=N-KEND
      IF(KEND) 5,5,2
    2 J=IND
      DO 4 K=1,KEND
      WORK=0.D0
      MIN=MIN-1
      LHOR=IPIV
      LVER=J
      DO 3 L=LANF,MIN
      LVER=LVER+1
      LHOR=LHOR+L
    3 WORK=WORK+DBLE(A(LVER)*A(LHOR))
      A(J)=-WORK*DIN
    4 J=J-MIN
    5 IPIV=IPIV-MIN
    6 IND=IND-1
      DO 8 I=1,N
      IPIV=IPIV+I
      J=IPIV
      DO 8 K=I,N
      WORK=0.D0
      LHOR=J
      DO 7 L=K,N
      LVER=LHOR+K-I
      WORK=WORK+DBLE(A(LHOR)*A(LVER))
    7 LHOR=LHOR+L
      A(J)=WORK*DBLE(VA)
    8 J=J+K
      RETURN
      END      
