c     FORTRAN77 code
c     File: tlsest.for
c
c     This program is intended for nonlinear error correction models
c     It estimates a bivariate nonlinear error correction model
c
c     Created by Antoni Vidiella to analyze interest rates
c
c     The program estimates a threshold-regression model: threshold
c     variable and its threshold must be given. 
c     It performs TSLS in each regime
ccccc Current setting
c
c     Number-variables = 2
c     max-ar-p = 29
c     max-obs  = 500
c     maximum number of regimes = 5
c
ccccc Definition of variables
c
      implicit real*8 (a-h,o-z)
      parameter(nmax=500,mk=3,ipmax=3,kmax=20,ithmax=5)
      dimension dat(nmax,ipmax),err(nmax),er(ipmax,ipmax)
      dimension dat2(nmax,ipmax),dat3(nmax,ipmax),dat4(nmax,ipmax)
      dimension npts(mk),y1(ipmax,nmax),x1(ipmax,nmax),x2(nmax,ipmax)
      dimension x3(ipmax,ipmax),x4(ipmax,ipmax),x5(ipmax,nmax)
      dimension x6(nmax,nmax),x9(nmax,1),x13(ipmax,1),x17(1,nmax)
      dimension x7(nmax,nmax),x8(ipmax,nmax),coef2(ipmax,1)
      dimension x10(nmax,1),x11(ipmax,1),x12(ipmax,nmax)
      dimension x14(1,ipmax),x15(1,1),h(ipmax,1),x16(nmax,ipmax)
      dimension x18(ipmax,nmax),x19(ipmax,nmax),d(ipmax,ipmax)
      dimension x22(1,nmax),x23(1,1),x24(kmax,kmax),elp1(ipmax,ipmax)      
      dimension x26(kmax,kmax),x27(kmax,kmax),x28(kmax,kmax)
      dimension x29(kmax,kmax),x30(ipmax,nmax),x31(ipmax,nmax)
      dimension x32(ipmax,nmax),x33(nmax,ipmax),x34(ipmax,kmax)
      dimension x35(2*kmax,2*kmax),thr(ithmax),x20(ipmax,1)
      dimension xm(nmax,nmax),elp(kmax,kmax),x25(kmax,kmax)
      dimension coef3(ipmax,1),h2(1,ipmax),c4(ipmax,1)
      dimension pi2(ipmax,ipmax),d7(ipmax,ipmax),pi3(ipmax,ipmax)
      dimension h3(1,ipmax),h4(1,1),h5(1,1),d8(ipmax,1)
      dimension pi(ipmax,ipmax),erpi(ipmax,ipmax),coef4(1,ipmax)
      dimension h6(1,ipmax),h8(ipmax,1),c5(ipmax,1),h10(ipmax,1)
      dimension h11(ipmax,1),h9(ipmax,1),h13(1,ipmax)
c
      character nfile*30
      external eqmat,zeromat,addmat,matinv,trnmat,multmat
c
      open (10,file='tvest.res',status='unknown')
      open (11,file='resid.res',status='unknown')
      open (12,file='stdrs.res',status='unknown')
c
ccccc Introduction of data
c
      write(6,1)
      write(10,47)
      write(10,501)
      write(10,1)
 47   format(1x,'ESTIMATION OUTPUT OF A TVECM')
      write(10,501)
 1    format(1x,'N.obs, delay, nregime :')
      read(5,*) nob, id, nreg
      ict=1
      write(10,11) nob, id, nreg, ict
 11   format(1x,i5,3x,i5,3x,i5,3x,i5)          
      if (nob.le.0) stop
      if (nob.gt.nmax) nob=nmax
      if (id.lt.0) id=0
      write(10,501)
      write(6,2)
      write(10,2)
 2    format(1x,'Data File Name : ')
      read (5,3) nfile
      write(10,3) ' ',nfile
      write(10,501)
 3    format(a30)
      open(9,file=nfile,status='old')
      open(17,file='tvres.out',status='unknown')
      open(18,file='tvest.out',status='unknown')
      kind=4
      write(18,*) kind
      write(18,*) ict
      nob1=nob
      call zeromat(dat,nmax,nmax,ipmax)
      do 10 i=1,nob
 10       read(9,*) (dat(i,j),j=1,2)
      close(9)
      write (6,6)
      ist=2
 6    format(1x,'input data span (1= yes) : ')
      read(5,*) ii
      if (ii.eq.1) then         
	write(6,12)
	read(5,*) ist, nend
	write(10,7) ist,nend
	write(10,501)
	if(nend.gt.nob) nend=nob
	if(ist.lt.1) ist = 1
	nob = nend-ist+1
	if(ist.eq.1)go to 30
	do 20 it=1, nob
	   do 20 i=1, 2
 20           dat(it,i) = dat(it-1+ist,i)
      endif
 7    format(1x,'Range of data: ',i4,'-',i4)
 12   format(1x,'data span (nst, nend): ')
 30   continue
      if(nreg.gt.1)then 
c--------- input thresholds
	 write(6,40) nreg-1
	 read(5,*) (thr(i),i = 2, nreg)
	 do 43 i=1,nreg-1
 43        write(10,41) thr(1+i) 
	 write(6,50)
	 read(5,*) b1
	 write(10,501)
	 write(10,*) 'Slope of threshold equation : ',b1
	 do 44 it=1, nob
	 err(it)=dat(it,1)-b1*dat(it,2)
 44      dat(it,3)=err(it)
      endif
      thr(1) = -9.9d+10
      i = nreg+1
      thr(i) = 9.9d+10
 40   format(1x,'input', i5,' thresholds: ')
 41   format(1x,'Threshold : ',f10.5)
      nob=nob-1
      do 46 i=1,nob
	 do 46 j=1,2
 46        dat2(i,j)= dat(i+1,j)-dat(i,j)              
 50   format(1x,'Enter beta parameter in threshold equation :')
      ip=2
c------------------- icnt: number of data points in this regime.
      do 90 ia=1,nreg
	 icnt = 0
	 do 100 it = ist, nob
	    chk = dat(it-id,3)  
	    if(chk.lt.thr(ia)) go to 100
	    if(chk.gt.thr(ia+1)) go to 100
c------------- the observation is in the ia-th regime
	    icnt = icnt+1
	    do 52 ij=1,2
	       dat3(icnt,ij)=dat2(it,ij)
 52            dat4(icnt,ij)=dat(it,ij)
c el valors introduits a dat4, son el de -1, i els poso a Y-1
c
 100     continue
c
      write(10,501)
      write(10,500)
      write(10,501)
      npts(ia) = icnt
      if (icnt.le.20) then
	 print*,'insufficient data points in the', ia,'-th regime'
	 stop
      endif
      call reg(dat4,nmax,icnt,b2,s5,rsq,dw)
      write(10,501)
      write(10,995) rsq
      write(10,501)
      write(10,994) dw
 995  format(2x,'R-squared of CE : ',f8.5)
 994  format(2x,'Durbin-Watson Statistic : ',f8.5)
c      ara tinc les dades necessaries a dat3 i dat4, amb el numero de dades tb
c      en principi ja podria comencar a fer la estimacio per a cada regim
c      en ip hi ha l'ordre del proces (ara inicialment 2)
      do 200 i=ip,icnt
	 do 200 j=1,2
 200        y1(j,i-1)=dat3(i,j)
      do 210 i=1,icnt-ip+1
	 if (ict.eq.1) x1(1,i)=1.0
	 do 210 j=1,ip-1
	     do 210 k=1,2
 210            x1(ict+k+2*(j-1),i)=dat3(i+ip-j-1,k)
      call zeromat(xm,nmax,icnt,icnt)
      do 220 i=1,icnt
 220     xm(i,i)=1.0
c     ara anem a calcular el valor de xm
      ior=(ip-1)*2+ict
      call trnmat(x1,x2,ipmax,nmax,ior,icnt)
      call multmat(x1,x2,x3,ipmax,nmax,ior,icnt,ior)
      call matinv(x3,x4,elp1,ipmax,ior,ifail)      
      call multmat(x4,x1,x5,ipmax,ipmax,ior,ior,icnt)
      call multmat(x2,x5,x6,nmax,ipmax,icnt,ior,icnt)
      call addmat(xm,x6,x7,nmax,icnt,icnt,-1)
c   x7 es la matriu m, ara es el moment de calcular Y-p, x8
      call trnmat(dat4,x8,nmax,ipmax,icnt,2)
c   ara calculem el numerador
      coef2(1,1)=1.0
      coef2(2,1)=-b2
      call multmat(dat4,coef2,x9,nmax,ipmax,icnt,2,1)
      call multmat(x7,x9,x10,nmax,nmax,icnt,icnt,1)
      call multmat(y1,x10,x11,ipmax,nmax,2,icnt,1)
c   x11, es el numerador, ara calculem el denominador
      call trnmat(dat4,x12,nmax,ipmax,icnt,2)
      call multmat(x12,x10,x13,ipmax,nmax,2,icnt,1)
      call trnmat(coef2,x14,ipmax,1,2,1)
      call multmat(x14,x13,x15,1,ipmax,1,2,1)
      do 230 i=1,2
 230     h(i,1)=-x11(i,1)/x15(1,1)
c   ara ja em calculat la matriu h de desmultplicacio, falta calcular la
c   matriu D de coeficients dels parametres
      call multmat(x2,x4,x16,nmax,ipmax,icnt,ior,ior)
c  part de la dreta
      call multmat(x14,x12,x17,1,ipmax,1,2,icnt)
      call multmat(h,x17,x18,ipmax,1,2,1,icnt)
      call addmat(y1,x18,x19,ipmax,2,icnt,1)
      call multmat(x19,x16,d,ipmax,nmax,2,icnt,ior)
      do 231 iz=1,2
 231     write(18,*) (d(iz,iw),iw=1,ior)
      cep=0.0
      write(18,*) b2,cep
      write(18,*) (h(i,1),i=1,2)
      call trnmat(coef2,coef4,ipmax,1,2,1)
c  estimation of drift parameteres, coef3 ortogonal
      if (ict.eq.1) then
	 coef3(1,1)=-coef2(2,1)
	 coef3(2,1)=1.0
	 h2(1,1)=-h(2,1)
	 h2(1,2)=h(1,1)
c  computation of pi function
	 call zeromat(pi2,ipmax,ipmax,ipmax)
	 do 232 i=1,2
	    c4(i,1)=d(i,1)
	    pi2(i,i)=1.0
	    do 232 j=1,2
 232           d7(i,j)=d(i,1+j)
	 call addmat(pi2,d7,pi3,ipmax,2,2,-1)
	 call multmat(h2,pi3,h3,1,ipmax,1,2,2)
	 call multmat(h3,coef3,h4,1,ipmax,1,2,1)
	 h4(1,1)=1.0/h4(1,1)
	 call multmat(h2,c4,h5,1,ipmax,1,2,1)
	 h4(1,1)=h4(1,1)*h5(1,1)
	 h5(1,1)=0.0
	 do 233 i=1,2
 233        d8(i,1)=coef3(i,1)*h4(1,1)
	 write(10,501)
	 do 308 i=1,2
 308        write(10,516) i,d8(i,1)
c
c
	 call trnmat(h,h13,ipmax,1,2,1)
	 call multmat(h13,h,h5,1,ipmax,1,2,1)
	 h5(1,1)=1.0/h5(1,1)
c         do 241 i=1,2
c 241        h6(1,i)=h5(1,1)*coef4(1,i)
	 call multmat(h5,h13,h6,1,1,1,1,2)
c
	 h5(1,1)=0.0
	 call multmat(pi3,d8,h8,ipmax,ipmax,2,2,1)
	 call addmat(c4,h8,c5,ipmax,2,1,-1)
c         do 242 i=1,2
c 242        c5(i,1)=c4(i,1)-h8(i,1)
	 call multmat(h6,c5,h5,1,ipmax,1,2,1)
	 write(10,501)
	 write(10,517) h5(1,1)
c  checking correctness
	 call multmat(h,h5,h9,ipmax,1,2,1,1)
	 call multmat(pi3,d8,h10,ipmax,ipmax,2,2,1)
	 call addmat(h9,h10,h11,ipmax,2,1,1)
ccccccc
	 call zeromat(coef3,ipmax,ipmax,1)
	 call zeromat(h2,1,1,ipmax)
	 call zeromat(c4,ipmax,ipmax,1)
	 call zeromat(d7,ipmax,ipmax,ipmax)
	 call zeromat(h3,1,1,ipmax)
	 call zeromat(h4,1,1,1)
	 call zeromat(h5,1,1,1)
	 call zeromat(d8,ipmax,ipmax,1)
	 call zeromat(h6,1,1,ipmax)
	 call zeromat(h8,ipmax,ipmax,1)
	 call zeromat(h9,ipmax,ipmax,1)
	 call zeromat(h10,ipmax,ipmax,1)
	 call zeromat(h11,ipmax,ipmax,1)
	 call zeromat(h13,1,1,ipmax)
	 call zeromat(c5,ipmax,ipmax,1)
      endif
      call multmat(x1,x9,x20,ipmax,nmax,ior,icnt,1)
      call trnmat(x9,x22,nmax,1,icnt,1)
      call multmat(x22,x9,x23,1,nmax,1,icnt,1)
      call eqmat(x3,x24,ipmax,kmax,ior,ior)
      do 239 i=1,ior
	 do 239 j=1,ior
 239        x24(i,j)=x24(i,j)/real(icnt)
      do 240 i=1,ior
	 x24(i,ior+1)=x20(i,1)/real(icnt)
 240      x24(ior+1,i)=x20(i,1)/real(icnt)
       x24(ior+1,ior+1)=x23(1,1)/real(icnt)
c       ja esta calculada la matriu omega
       call matinv(x24,x25,elp,kmax,ior+1,ifail)
       call zeromat(x26,kmax,ior+2,ior+2)
       do 250 i=1,ior
 250      x26(i,i)=1.0
       do 255 i=1,2    
 255      x26(ior+i,ior+1)=coef2(i,1)
       call multmat(x26,x25,x27,kmax,kmax,ior+2,ior+1,ior+1)
       call trnmat(x26,x28,kmax,kmax,ior+2,ior+1)
       call multmat(x27,x28,x29,kmax,kmax,ior+2,ior+1,ior+2)
c  a x29 hi ha la matriu omega per les altres dos ior+2*ior+2
       call multmat(d,x1,x30,ipmax,ipmax,2,ior,icnt)
       call addmat(x30,x18,x31,ipmax,2,icnt,-1)
c  a x31 hi ha la prediccio, ara toca calcular l'error de prediccio
       call addmat(y1,x31,x32,ipmax,2,icnt,-1)
       write(17,*) icnt
       do 256 i=1,icnt
 256      write(17,*) x32(1,i),x32(2,i)
c      a x32 hi ha els vectors d'errors
       call trnmat(x32,x33,ipmax,nmax,2,icnt)
       call multmat(x32,x33,x34,ipmax,nmax,2,icnt,2)
       do 260 i=1,2
	  do 260 j=1,2
	     x34(i,j)=x34(i,j)/real(icnt-1)
 260      write(18,*) x34(i,j)
c  a x34 hi ha la estimacio de la matriu de var-cov dels errors
c  ara s'ha de fer el producte de Kronecker de les dues matrius
       do 270 i=1,ior+2
	  do 270 j=1,ior+2
	     do 270 k=1,2
		do 270 l=1,2
 270               x35((i-1)*2+k,(j-1)*2+l)=x29(i,j)*x34(k,l)
c      una vegada calculat el producte de Kronecker ja podem calcular
c      la significabilitat dels parametres
       kl=0
       do 400 i=1,ior
	  do 400 j=1,2
	     kl=kl+1
 400         er(j,i)=dsqrt(x35(kl,kl)/real(icnt))
       do 410 i=1,2
	  do 410 j=1,2
	     kl=kl+1
 410         erpi(j,i)=dsqrt(x35(kl,kl)/real(icnt))
c       a er(j,i) hi ha els errors estndards d'estimacio
       call multmat(h,coef4,pi,ipmax,1,2,1,2)
       write(10,501)
       write(10,515) icnt
       write(10,501)
       write(10,502)
       write(10,501)
       write(10,503)
       write(10,504) b2,s5,b2/s5
       write(10,501)
       write(10,505)
       write(10,501)
       do 302 i=1,2
	  write(10,506) i
	  write(10,501)
	  write(10,503)
	  do 304 j=1,ior
 304         write(10,504) d(i,j),er(i,j),d(i,j)/er(i,j)
	  write(10,501)
 302   continue
       write(10,507)
       write(10,501)
       write(10,503)
       do 300 i=1,2
 300      write(10,504) h(i,1),h(i,1),h(i,1)
       write(10,501)
       write(10,508)
       do 306 i=1,2
	  write(10,506) i
	  write(10,501)
	  write(10,503)
	  do 306 j=1,2
 306      write(10,504) pi(i,j),erpi(i,j),pi(i,j)/erpi(i,j)
       write(10,501)
       write(10,511)
       do 307 i=1,2
 307      write(10,512)(x34(i,j),j=1,2)
 512      format(1x,5f12.5)
       call zeromat(er,ipmax,ipmax,ipmax)
       call zeromat(dat3,nmax,nmax,ipmax)
       call zeromat(dat4,nmax,nmax,ipmax)
       call zeromat(y1,ipmax,ipmax,nmax)
       call zeromat(x1,ipmax,ipmax,nmax)
       call zeromat(x2,nmax,nmax,ipmax)
       call zeromat(x3,ipmax,ipmax,ipmax)
       call zeromat(x4,ipmax,ipmax,ipmax)
       call zeromat(x5,ipmax,ipmax,nmax)
       call zeromat(x6,nmax,nmax,nmax)
       call zeromat(x9,nmax,nmax,1)
       call zeromat(x13,ipmax,ipmax,1)
       call zeromat(x17,1,1,nmax)
       call zeromat(x7,nmax,nmax,nmax)
       call zeromat(x8,ipmax,ipmax,nmax)
       call zeromat(coef2,ipmax,ipmax,1)
       call zeromat(x10,nmax,nmax,1)
       call zeromat(x11,ipmax,ipmax,1)
       call zeromat(x12,ipmax,ipmax,nmax)
       call zeromat(x14,1,1,ipmax)
       call zeromat(x15,1,1,1)
       call zeromat(h,ipmax,ipmax,1)
       call zeromat(x16,nmax,nmax,ipmax)
       call zeromat(x18,ipmax,ipmax,nmax)
       call zeromat(x19,ipmax,ipmax,nmax)
       call zeromat(d,ipmax,ipmax,ipmax)
       call zeromat(x22,1,1,nmax)
       call zeromat(x23,1,1,1)
       call zeromat(x24,kmax,kmax,kmax)
       call zeromat(elp1,ipmax,ipmax,ipmax)
       call zeromat(x26,kmax,kmax,kmax)
       call zeromat(x27,kmax,kmax,kmax)
       call zeromat(x28,kmax,kmax,kmax)
       call zeromat(x29,kmax,kmax,kmax)
       call zeromat(x30,ipmax,ipmax,nmax)
       call zeromat(x31,ipmax,ipmax,nmax)
       call zeromat(x32,ipmax,ipmax,nmax)
       call zeromat(x33,nmax,nmax,ipmax)
       call zeromat(x34,ipmax,ipmax,kmax)
       call zeromat(x35,2*kmax,2*kmax,2*kmax)
       call zeromat(x20,ipmax,ipmax,1)
       call zeromat(xm,nmax,nmax,nmax)
       call zeromat(elp,kmax,kmax,kmax)
       call zeromat(x25,kmax,kmax,kmax)
       call zeromat(coef3,1,1,ipmax)
       call zeromat(pi,ipmax,ipmax,ipmax)
       call zeromat(erpi,ipmax,ipmax,ipmax)
 90   continue
       write(18,*) nfile
       write(18,*) nob1
       write(18,*) b1
       write(18,*) thr(2)
 500   format(1x,'ESTIMATION RESULTS OF A TVECM 2-stages LS: ')
 501   format(' ')
 502   format(2x,'Cointegration Equation : ')
 503   format(2x,'Coefficient',5x,'Std.Errors',4x,'t-statistic')
 504   format(1x,f10.5,6x,f10.5,6x,f10.5)
 505   format(2x,'Error Correction : ')
 506   format(2x,'Component : ',i2)
 507   format(2x,'H vector :')
 508   format(2x,'HC matrix (estimation of PI matrix) : ')
 511   format(2x,'Residual Covariance Matrix: ')
 515   format(2x,'Number of points in this regime: ',i3)
 516   format(2x,'Long-run drift of variable ',i3,' : ',f10.5)
 517   format(2x,'Mean of cointegrating equation : ',f10.5)
       close(17)

      end       

      SUBROUTINE MULTMAT(AMAT,BMAT,CMAT,ID1MAX,ID2MAX,L1,L2,L3)
C**********************************************************************
C     PORPOSE: MATRIX MULTIPLICATION
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L2,L3
C     OUPUT: CMAT, MATRIX DIMENSION L1,L3
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      DO 99 J=1,L3
	 DO 98 K=1,L2
	    IF (BMAT(K,J).EQ.0.0) GOTO 98
	    DO 97 I=1,L1
	       CMAT(I,J)=CMAT(I,J)+AMAT(I,K)*BMAT(K,J)
   97       CONTINUE
   98    CONTINUE
   99 CONTINUE
      RETURN
      END

      SUBROUTINE MATINV(AMAT,BMAT,ELP,ID1MAX,L1,IFAIL)
C************************************************************************
C     PORPOSE: MATRIX INVERSION
C     INPUT: AMAT, MATRIX DIMENSION L1,L1
C     OUTPUT: BMAT, MATRIX DIMENSION L1,L1
C             IFAIL, MONITORING VALUE
C************************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),ELP(ID1MAX,*)
      EXTERNAL EQMAT,ZEROMAT
C     
      CALL ZEROMAT(ELP,ID1MAX,L1,L1)
      CALL EQMAT(AMAT,ELP,ID1MAX,ID1MAX,L1,L1)
      DO 115 I=1,L1
	 BMAT(I,I)=1.0
  115 CONTINUE
      DO 99 J=1,L1
	 DO 98 I=J,L1
	    IF (ELP(I,J).NE.0.0) GOTO 11
   98    CONTINUE
	 IFAIL=1
	 RETURN
   11    CONTINUE
      DO 97 K=1,L1
C
	 PIVOT01= ELP(J,K)
	 ELP(J,K)= ELP(I,K)
	 ELP(I,K)= PIVOT01
C
	 PIV= BMAT(J,K)
	 BMAT(J,K)=BMAT(I,K)
	 BMAT(I,K)= PIV
   97 CONTINUE
C
      IF(ELP(J,J).NE.0.0) GOTO 22
C
      IFAIL=1
      RETURN
C
C
   22 CONTINUE
      PPP= 1.0/ELP(J,J)
      DO 96 K=1,L1
C
	 ELP(J,K)= ELP(J,K)*PPP
	 BMAT(J,K)= BMAT(J,K)*PPP
   96 CONTINUE
C
      DO 95 K=1,L1
C
	 IF(J.EQ.K) THEN
C
   33       CONTINUE
C
	 ELSE
	    PPP= ELP(K,J)
	    DO 94 L=1,L1
C
	       ELP(K,L)=ELP(K,L)-ELP(J,L)*PPP
	       BMAT(K,L)=BMAT(K,L)-BMAT(J,L)*PPP
   94       CONTINUE
C
	 END IF
   95 CONTINUE
   99 CONTINUE
C
      RETURN
      END

     
      SUBROUTINE ZEROMAT(AMAT,ID1MAX,L1,L2)
C**************************************************************
C     PORPOSE: CREATE A MATRIX OF ZEROS
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: AMAT, ZEROED MATRIX DIMENSION L1,L2
C**************************************************************
      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*)
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    AMAT(I,J)=0.0
  99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ZEROVEC(VEC,ID1MAX,L1)
C**************************************************************
C     PORPOSE: CREATE A VECTOR OF ZEROS      
C     INPUT: VEC, VECTOR DIMENSION L1
C     OUTPUT: VEC, ZEROED VECTOR DIMENSION L1
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION VEC(ID1MAX)

      DO 98 I=1,L1     
		VEC(I)=0.0
  98  CONTINUE
      RETURN
	END
   
      SUBROUTINE EQMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C**************************************************************
C     PORPOSE: EQUALIZATION OF MATRICES 
C     INPUT: AMAT, MATRIX DIMENSION L1 L2
C     OUPUT: BMAT, MATRIX EQUAL AMAT DIMENSION L1 L2
C**************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
C
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(I,J)=AMAT(I,J)
   99    CONTINUE
   98 CONTINUE
      RETURN
      END

      SUBROUTINE EQVEC(VECA,VECB,ID1MAX,L1)
C******************************************************************
C     PORPOSE: EQUALIZATION OF VECTORS
C     INPUT: VECA, VECTOR DIMENSION L1
C     OUTPUT: VECB, VECTOR EQUAL VECA DIMENSON L1
C******************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION VECA(ID1MAX),VECB(ID1MAX)
C
      DO 99 I=1,L1
	    VECB(I)=VECA(I)
   99 CONTINUE
      RETURN
      END

      SUBROUTINE TRNMAT(AMAT,BMAT,ID1MAX,ID2MAX,L1,L2)
C********************************************************************
C     PORPOSE: TRANSPOSE A MATRIX OF DIMENSION L1,L2
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C     OUTPUT: BMAT, TRANSPOSED MATRIX DIMENSION L2,L1
C********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID2MAX,*)
C
      DO 98 J=1,L2
	 DO 99 I=1,L1
	    BMAT(J,I)=AMAT(I,J)
   99     CONTINUE
  98  CONTINUE
      RETURN
      END

      SUBROUTINE ADDMAT(AMAT,BMAT,CMAT,ID1MAX,L1,L2,IND)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION AMAT(ID1MAX,*),BMAT(ID1MAX,*),CMAT(ID1MAX,*)
      EXTERNAL ZEROMAT
      CALL ZEROMAT(CMAT,ID1MAX,L1,L3)
      DO 2 J=1,L1
	 DO 2 K=1,L2
 2          CMAT(J,K)=AMAT(J,K)+IND*BMAT(J,K)
      RETURN
      END

      SUBROUTINE reg(dat,ID1MAX,nob,b1,s4,rsq,dw)
C**********************************************************************
C     PORPOSE: MATRIX SUM
C     INPUT: AMAT, MATRIX DIMENSION L1,L2
C            BMAT, MATRIX DIMENSION L1,L2
C            IND,  INDICATOR VARIABLE: 1, ADD
C                                     -1, EXTRACT
C     OUPUT: CMAT, MATRIX DIMENSION L1,L2
C**********************************************************************

      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION dat(ID1MAX,*),se(500)
      b1=0.0
      s1=0.0
      s2=0.0
      s3=0.0
      s4=0.0
      s5=0.0
      s6=0.0
      s7=0.0
      call zerovec(se,500,500)
      do 100 i=1,nob
	 s5=s5+dat(i,1)
	 s1=s1+dat(i,1)*dat(i,2)
 100     s2=s2+dat(i,2)**2
      b1=s1/s2
      rmean=s5/real(nob)
      do 45 i=1,nob
	 s6=s6+(dat(i,1)-rmean)**2
	 se(i)=(dat(i,1)-b1*dat(i,2))**2
 45      s3=s3+se(i)
      do 56 j=2,nob
 56      s7=s7+sqrt(se(j-1)*se(j))
      s4=(s3/(s2*(real(nob-1))))**0.5
      rsq=1.0-(s3/s6)
      dw=2.0*(1.0-(s7/s3))
      end

